[detherjs](../README.md) › [Globals](../globals.md) › ["core/exchanges/base"](../modules/_core_exchanges_base_.md) › [ExchangeBase](_core_exchanges_base_.exchangebase.md)

# Class: ExchangeBase

## Hierarchy

* **ExchangeBase**

  ↳ [ExchangeUniswap](_core_exchanges_uniswap_.exchangeuniswap.md)

## Index

### Constructors

* [constructor](_core_exchanges_base_.exchangebase.md#constructor)

### Properties

* [buyToken](_core_exchanges_base_.exchangebase.md#buytoken)
* [name](_core_exchanges_base_.exchangebase.md#name)
* [sellToken](_core_exchanges_base_.exchangebase.md#selltoken)

### Methods

* [estimate](_core_exchanges_base_.exchangebase.md#estimate)
* [trade](_core_exchanges_base_.exchangebase.md#trade)
* [tradeFromSell](_core_exchanges_base_.exchangebase.md#tradefromsell)
* [trade_delayed](_core_exchanges_base_.exchangebase.md#trade_delayed)

## Constructors

###  constructor

\+ **new ExchangeBase**(`sellToken`: string, `buyToken`: string): *[ExchangeBase](_core_exchanges_base_.exchangebase.md)*

*Defined in [core/exchanges/base.ts:11](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/exchanges/base.ts#L11)*

**Parameters:**

Name | Type |
------ | ------ |
`sellToken` | string |
`buyToken` | string |

**Returns:** *[ExchangeBase](_core_exchanges_base_.exchangebase.md)*

## Properties

###  buyToken

• **buyToken**: *string*

*Defined in [core/exchanges/base.ts:10](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/exchanges/base.ts#L10)*

___

###  name

• **name**: *[Exchange](../enums/_types_.exchange.md)*

*Defined in [core/exchanges/base.ts:11](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/exchanges/base.ts#L11)*

___

###  sellToken

• **sellToken**: *string*

*Defined in [core/exchanges/base.ts:9](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/exchanges/base.ts#L9)*

## Methods

###  estimate

▸ **estimate**(`sellAmount`: string, `provider`: Provider): *Promise‹string›*

*Defined in [core/exchanges/base.ts:16](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/exchanges/base.ts#L16)*

**Parameters:**

Name | Type |
------ | ------ |
`sellAmount` | string |
`provider` | Provider |

**Returns:** *Promise‹string›*

___

###  trade

▸ **trade**(`sellAmount`: string, `buyAmount`: string, `wallet`: Wallet, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction | void›*

*Defined in [core/exchanges/base.ts:22](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/exchanges/base.ts#L22)*

**Parameters:**

Name | Type |
------ | ------ |
`sellAmount` | string |
`buyAmount` | string |
`wallet` | Wallet |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction | void›*

___

###  tradeFromSell

▸ **tradeFromSell**(`sellAmount`: string, `buyAmount`: string, `destAddress`: string, `wallet`: Wallet, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction | void›*

*Defined in [core/exchanges/base.ts:30](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/exchanges/base.ts#L30)*

**Parameters:**

Name | Type |
------ | ------ |
`sellAmount` | string |
`buyAmount` | string |
`destAddress` | string |
`wallet` | Wallet |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction | void›*

___

###  trade_delayed

▸ **trade_delayed**(`sellAmount`: string, `buyAmount`: string, `wallet`: Wallet, `nonce`: number, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction | void›*

*Defined in [core/exchanges/base.ts:39](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/exchanges/base.ts#L39)*

**Parameters:**

Name | Type |
------ | ------ |
`sellAmount` | string |
`buyAmount` | string |
`wallet` | Wallet |
`nonce` | number |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction | void›*
