[detherjs](../README.md) › [Globals](../globals.md) › ["core/exchanges/uniswap"](../modules/_core_exchanges_uniswap_.md) › [ExchangeUniswap](_core_exchanges_uniswap_.exchangeuniswap.md)

# Class: ExchangeUniswap

## Hierarchy

* [ExchangeBase](_core_exchanges_base_.exchangebase.md)

  ↳ **ExchangeUniswap**

## Index

### Constructors

* [constructor](_core_exchanges_uniswap_.exchangeuniswap.md#constructor)

### Properties

* [buyToken](_core_exchanges_uniswap_.exchangeuniswap.md#buytoken)
* [name](_core_exchanges_uniswap_.exchangeuniswap.md#name)
* [sellToken](_core_exchanges_uniswap_.exchangeuniswap.md#selltoken)

### Methods

* [estimate](_core_exchanges_uniswap_.exchangeuniswap.md#estimate)
* [trade](_core_exchanges_uniswap_.exchangeuniswap.md#trade)
* [tradeFromSell](_core_exchanges_uniswap_.exchangeuniswap.md#tradefromsell)
* [trade_delayed](_core_exchanges_uniswap_.exchangeuniswap.md#trade_delayed)

## Constructors

###  constructor

\+ **new ExchangeUniswap**(`sellToken`: string, `buyToken`: string): *[ExchangeUniswap](_core_exchanges_uniswap_.exchangeuniswap.md)*

*Overrides [ExchangeBase](_core_exchanges_base_.exchangebase.md).[constructor](_core_exchanges_base_.exchangebase.md#constructor)*

*Defined in [core/exchanges/uniswap.ts:9](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/exchanges/uniswap.ts#L9)*

**Parameters:**

Name | Type |
------ | ------ |
`sellToken` | string |
`buyToken` | string |

**Returns:** *[ExchangeUniswap](_core_exchanges_uniswap_.exchangeuniswap.md)*

## Properties

###  buyToken

• **buyToken**: *string*

*Inherited from [ExchangeBase](_core_exchanges_base_.exchangebase.md).[buyToken](_core_exchanges_base_.exchangebase.md#buytoken)*

*Defined in [core/exchanges/base.ts:10](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/exchanges/base.ts#L10)*

___

###  name

• **name**: *[Exchange](../enums/_types_.exchange.md)*

*Inherited from [ExchangeBase](_core_exchanges_base_.exchangebase.md).[name](_core_exchanges_base_.exchangebase.md#name)*

*Defined in [core/exchanges/base.ts:11](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/exchanges/base.ts#L11)*

___

###  sellToken

• **sellToken**: *string*

*Inherited from [ExchangeBase](_core_exchanges_base_.exchangebase.md).[sellToken](_core_exchanges_base_.exchangebase.md#selltoken)*

*Defined in [core/exchanges/base.ts:9](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/exchanges/base.ts#L9)*

## Methods

###  estimate

▸ **estimate**(`sellAmount`: string, `provider`: Provider): *Promise‹string›*

*Overrides [ExchangeBase](_core_exchanges_base_.exchangebase.md).[estimate](_core_exchanges_base_.exchangebase.md#estimate)*

*Defined in [core/exchanges/uniswap.ts:15](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/exchanges/uniswap.ts#L15)*

**Parameters:**

Name | Type |
------ | ------ |
`sellAmount` | string |
`provider` | Provider |

**Returns:** *Promise‹string›*

___

###  trade

▸ **trade**(`sellAmount`: string, `buyAmount`: string, `wallet`: Wallet, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Overrides [ExchangeBase](_core_exchanges_base_.exchangebase.md).[trade](_core_exchanges_base_.exchangebase.md#trade)*

*Defined in [core/exchanges/uniswap.ts:62](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/exchanges/uniswap.ts#L62)*

**Parameters:**

Name | Type |
------ | ------ |
`sellAmount` | string |
`buyAmount` | string |
`wallet` | Wallet |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction›*

___

###  tradeFromSell

▸ **tradeFromSell**(`sellAmount`: string, `buyAmount`: string, `destAddress`: string, `wallet`: Wallet, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Overrides [ExchangeBase](_core_exchanges_base_.exchangebase.md).[tradeFromSell](_core_exchanges_base_.exchangebase.md#tradefromsell)*

*Defined in [core/exchanges/uniswap.ts:42](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/exchanges/uniswap.ts#L42)*

**Parameters:**

Name | Type |
------ | ------ |
`sellAmount` | string |
`buyAmount` | string |
`destAddress` | string |
`wallet` | Wallet |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction›*

___

###  trade_delayed

▸ **trade_delayed**(`sellAmount`: string, `buyAmount`: string, `wallet`: Wallet, `nonce`: number, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹any›*

*Overrides [ExchangeBase](_core_exchanges_base_.exchangebase.md).[trade_delayed](_core_exchanges_base_.exchangebase.md#trade_delayed)*

*Defined in [core/exchanges/uniswap.ts:92](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/exchanges/uniswap.ts#L92)*

**Parameters:**

Name | Type |
------ | ------ |
`sellAmount` | string |
`buyAmount` | string |
`wallet` | Wallet |
`nonce` | number |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹any›*
