[detherjs](../README.md) › [Globals](../globals.md) › ["dether"](../modules/_dether_.md) › [DetherJS](_dether_.detherjs.md)

# Class: DetherJS

This is the main detherJS object

## Hierarchy

* **DetherJS**

## Index

### Constructors

* [constructor](_dether_.detherjs.md#constructor)

### Properties

* [dthContract](_dether_.detherjs.md#dthcontract)
* [encryptedWallet](_dether_.detherjs.md#encryptedwallet)
* [geoRegistryContract](_dether_.detherjs.md#georegistrycontract)
* [network](_dether_.detherjs.md#network)
* [provider](_dether_.detherjs.md#provider)
* [shopsContract](_dether_.detherjs.md#shopscontract)
* [usingMetamask](_dether_.detherjs.md#usingmetamask)
* [zoneFactoryContract](_dether_.detherjs.md#zonefactorycontract)

### Methods

* [addShop](_dether_.detherjs.md#addshop)
* [addTeller](_dether_.detherjs.md#addteller)
* [addTellerComment](_dether_.detherjs.md#addtellercomment)
* [approveToken](_dether_.detherjs.md#approvetoken)
* [bidZone](_dether_.detherjs.md#bidzone)
* [claimFreeZone](_dether_.detherjs.md#claimfreezone)
* [collectShopTaxes](_dether_.detherjs.md#collectshoptaxes)
* [createZone](_dether_.detherjs.md#createzone)
* [deleteUserShop](_dether_.detherjs.md#deleteusershop)
* [execExchange](_dether_.detherjs.md#execexchange)
* [execExchangeFromSell](_dether_.detherjs.md#execexchangefromsell)
* [execExchange_delayed](_dether_.detherjs.md#execexchange_delayed)
* [getAllBalance](_dether_.detherjs.md#getallbalance)
* [getAvailableToken](_dether_.detherjs.md#getavailabletoken)
* [getAvailableTokenDecimals](_dether_.detherjs.md#getavailabletokendecimals)
* [getERC20Info](_dether_.detherjs.md#geterc20info)
* [getExchangeEstimation](_dether_.detherjs.md#getexchangeestimation)
* [getLicencePriceInZone](_dether_.detherjs.md#getlicencepriceinzone)
* [getOpenBid](_dether_.detherjs.md#getopenbid)
* [getShopByAddress](_dether_.detherjs.md#getshopbyaddress)
* [getShopByPosition](_dether_.detherjs.md#getshopbyposition)
* [getShopsInZone](_dether_.detherjs.md#getshopsinzone)
* [getShopsInZones](_dether_.detherjs.md#getshopsinzones)
* [getTeller](_dether_.detherjs.md#getteller)
* [getTellerInZone](_dether_.detherjs.md#gettellerinzone)
* [getTellersInZones](_dether_.detherjs.md#gettellersinzones)
* [getTokenLiquidity](_dether_.detherjs.md#gettokenliquidity)
* [getTransactionStatus](_dether_.detherjs.md#gettransactionstatus)
* [getZoneByAddress](_dether_.detherjs.md#getzonebyaddress)
* [getZoneByGeohash](_dether_.detherjs.md#getzonebygeohash)
* [getZonesStatus](_dether_.detherjs.md#getzonesstatus)
* [hasApproval](_dether_.detherjs.md#hasapproval)
* [hasProvider](_dether_.detherjs.md#private-hasprovider)
* [hasWallet](_dether_.detherjs.md#private-haswallet)
* [init](_dether_.detherjs.md#init)
* [initProvider](_dether_.detherjs.md#initprovider)
* [isBidderOnthisAuction](_dether_.detherjs.md#isbidderonthisauction)
* [isTeller](_dether_.detherjs.md#isteller)
* [isZoneOpened](_dether_.detherjs.md#iszoneopened)
* [isZoneOwned](_dether_.detherjs.md#iszoneowned)
* [isZoneOwner](_dether_.detherjs.md#iszoneowner)
* [loadUser](_dether_.detherjs.md#loaduser)
* [loadWallet](_dether_.detherjs.md#private-loadwallet)
* [processState](_dether_.detherjs.md#processstate)
* [releaseZone](_dether_.detherjs.md#releasezone)
* [removeShop](_dether_.detherjs.md#removeshop)
* [removeTeller](_dether_.detherjs.md#removeteller)
* [sendCrypto](_dether_.detherjs.md#sendcrypto)
* [setCustomContractAddresses](_dether_.detherjs.md#setcustomcontractaddresses)
* [setShopLicencePrice](_dether_.detherjs.md#setshoplicenceprice)
* [shopExistsByAddress](_dether_.detherjs.md#shopexistsbyaddress)
* [signMessage](_dether_.detherjs.md#signmessage)
* [topUpShop](_dether_.detherjs.md#topupshop)
* [topUpZone](_dether_.detherjs.md#topupzone)
* [updateTeller](_dether_.detherjs.md#updateteller)
* [withdrawAuctionsRaw](_dether_.detherjs.md#withdrawauctionsraw)
* [withdrawZoneAuctionBid](_dether_.detherjs.md#withdrawzoneauctionbid)
* [withdrawZoneAuctionBidAddress](_dether_.detherjs.md#withdrawzoneauctionbidaddress)
* [withdrawZoneAuctionsBid](_dether_.detherjs.md#withdrawzoneauctionsbid)
* [withdrawZoneAuctionsBidAddress](_dether_.detherjs.md#withdrawzoneauctionsbidaddress)
* [withdrawZoneOwnerDth](_dether_.detherjs.md#withdrawzoneownerdth)
* [withdrawZoneOwnerDthAddress](_dether_.detherjs.md#withdrawzoneownerdthaddress)

## Constructors

###  constructor

\+ **new DetherJS**(`useMetamask`: boolean): *[DetherJS](_dether_.detherjs.md)*

*Defined in [dether.ts:40](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L40)*

You can either use it with your own ethersjs wallet, or with metamask.
<pre><code>
const detherjs = new DetherJS(false)
</code></pre>

**Parameters:**

Name | Type |
------ | ------ |
`useMetamask` | boolean |

**Returns:** *[DetherJS](_dether_.detherjs.md)*

## Properties

###  dthContract

• **dthContract**: *Contract*

*Defined in [dether.ts:40](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L40)*

___

###  encryptedWallet

• **encryptedWallet**: *string*

*Defined in [dether.ts:34](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L34)*

___

###  geoRegistryContract

• **geoRegistryContract**: *Contract*

*Defined in [dether.ts:38](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L38)*

___

###  network

• **network**: *any*

*Defined in [dether.ts:36](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L36)*

___

###  provider

• **provider**: *any*

*Defined in [dether.ts:35](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L35)*

___

###  shopsContract

• **shopsContract**: *Contract*

*Defined in [dether.ts:39](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L39)*

___

###  usingMetamask

• **usingMetamask**: *boolean*

*Defined in [dether.ts:33](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L33)*

___

###  zoneFactoryContract

• **zoneFactoryContract**: *Contract*

*Defined in [dether.ts:37](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L37)*

## Methods

###  addShop

▸ **addShop**(`password`: string, `shopData`: [IShopArgs](../interfaces/_types_.ishopargs.md), `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [dether.ts:444](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L444)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`password` | string | - |
`shopData` | [IShopArgs](../interfaces/_types_.ishopargs.md) | - |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) | constants.DEFAULT_TX_OPTIONS |

**Returns:** *Promise‹ContractTransaction›*

___

###  addTeller

▸ **addTeller**(`password`: string, `tellerData`: [ITellerArgs](../interfaces/_types_.itellerargs.md), `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [dether.ts:343](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L343)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`password` | string | - |
`tellerData` | [ITellerArgs](../interfaces/_types_.itellerargs.md) | - |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) | constants.DEFAULT_TX_OPTIONS |

**Returns:** *Promise‹ContractTransaction›*

___

###  addTellerComment

▸ **addTellerComment**(`password`: string, `zoneGeohash`: string, `ipfsHash`: string, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [dether.ts:391](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L391)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`password` | string | - |
`zoneGeohash` | string | - |
`ipfsHash` | string | - |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) | constants.DEFAULT_TX_OPTIONS |

**Returns:** *Promise‹ContractTransaction›*

___

###  approveToken

▸ **approveToken**(`password`: string, `token`: [Token](../enums/_types_.token.md), `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [dether.ts:292](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L292)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`password` | string | - |
`token` | [Token](../enums/_types_.token.md) | - |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) | constants.DEFAULT_TX_OPTIONS |

**Returns:** *Promise‹ContractTransaction›*

___

###  bidZone

▸ **bidZone**(`password`: string, `geohash6`: string, `bidAmount`: number, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [dether.ts:633](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L633)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`password` | string | - |
`geohash6` | string | - |
`bidAmount` | number | - |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) | constants.DEFAULT_TX_OPTIONS |

**Returns:** *Promise‹ContractTransaction›*

___

###  claimFreeZone

▸ **claimFreeZone**(`password`: string, `geohash6`: string, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [dether.ts:616](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L616)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`password` | string | - |
`geohash6` | string | - |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) | constants.DEFAULT_TX_OPTIONS |

**Returns:** *Promise‹ContractTransaction›*

___

###  collectShopTaxes

▸ **collectShopTaxes**(`password`: string, `geohash6`: string, `start`: number, `end`: number, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [dether.ts:507](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L507)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`password` | string | - |
`geohash6` | string | - |
`start` | number | - |
`end` | number | - |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) | constants.DEFAULT_TX_OPTIONS |

**Returns:** *Promise‹ContractTransaction›*

___

###  createZone

▸ **createZone**(`password`: string, `country`: string, `geohash6`: string, `amount`: number, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [dether.ts:595](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L595)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`password` | string | - |
`country` | string | - |
`geohash6` | string | - |
`amount` | number | - |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) | constants.DEFAULT_TX_OPTIONS |

**Returns:** *Promise‹ContractTransaction›*

___

###  deleteUserShop

▸ **deleteUserShop**(`password`: string, `geohash6`: string, `shopAddress`: string, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [dether.ts:527](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L527)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`password` | string | - |
`geohash6` | string | - |
`shopAddress` | string | - |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) | constants.DEFAULT_TX_OPTIONS |

**Returns:** *Promise‹ContractTransaction›*

___

###  execExchange

▸ **execExchange**(`password`: string, `sellToken`: [Token](../enums/_types_.token.md), `buyToken`: [Token](../enums/_types_.token.md), `sellAmount`: string, `buyAmount`: string, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [dether.ts:187](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L187)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`password` | string | - |
`sellToken` | [Token](../enums/_types_.token.md) | - |
`buyToken` | [Token](../enums/_types_.token.md) | - |
`sellAmount` | string | - |
`buyAmount` | string | - |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) | constants.DEFAULT_TX_OPTIONS |

**Returns:** *Promise‹ContractTransaction›*

___

###  execExchangeFromSell

▸ **execExchangeFromSell**(`password`: string, `buyToken`: [Token](../enums/_types_.token.md), `sellAmount`: string, `buyAmount`: string, `destAddress`: string, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [dether.ts:234](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L234)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`password` | string | - |
`buyToken` | [Token](../enums/_types_.token.md) | - |
`sellAmount` | string | - |
`buyAmount` | string | - |
`destAddress` | string | - |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) | constants.DEFAULT_TX_OPTIONS |

**Returns:** *Promise‹ContractTransaction›*

___

###  execExchange_delayed

▸ **execExchange_delayed**(`password`: string, `sellToken`: [Token](../enums/_types_.token.md), `buyToken`: [Token](../enums/_types_.token.md), `sellAmount`: string, `buyAmount`: string, `nonce`: number, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹any›*

*Defined in [dether.ts:210](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L210)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`password` | string | - |
`sellToken` | [Token](../enums/_types_.token.md) | - |
`buyToken` | [Token](../enums/_types_.token.md) | - |
`sellAmount` | string | - |
`buyAmount` | string | - |
`nonce` | number | - |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) | constants.DEFAULT_TX_OPTIONS |

**Returns:** *Promise‹any›*

___

###  getAllBalance

▸ **getAllBalance**(`address`: string, `tickers`: [ITicker](../interfaces/_types_.iticker.md)[]): *Promise‹[IBalances](../interfaces/_types_.ibalances.md)[]›*

*Defined in [dether.ts:155](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L155)*

**Parameters:**

Name | Type |
------ | ------ |
`address` | string |
`tickers` | [ITicker](../interfaces/_types_.iticker.md)[] |

**Returns:** *Promise‹[IBalances](../interfaces/_types_.ibalances.md)[]›*

___

###  getAvailableToken

▸ **getAvailableToken**(`forLogo?`: false): *Promise‹[ITicker](../interfaces/_types_.iticker.md)›*

*Defined in [dether.ts:254](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L254)*

**Parameters:**

Name | Type |
------ | ------ |
`forLogo?` | false |

**Returns:** *Promise‹[ITicker](../interfaces/_types_.iticker.md)›*

___

###  getAvailableTokenDecimals

▸ **getAvailableTokenDecimals**(`forLogo?`: false): *Promise‹any›*

*Defined in [dether.ts:259](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L259)*

**Parameters:**

Name | Type |
------ | ------ |
`forLogo?` | false |

**Returns:** *Promise‹any›*

___

###  getERC20Info

▸ **getERC20Info**(`address`: string): *Promise‹[ITicker](../interfaces/_types_.iticker.md)›*

*Defined in [dether.ts:150](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L150)*

**Parameters:**

Name | Type |
------ | ------ |
`address` | string |

**Returns:** *Promise‹[ITicker](../interfaces/_types_.iticker.md)›*

___

###  getExchangeEstimation

▸ **getExchangeEstimation**(`sellToken`: [Token](../enums/_types_.token.md), `buyToken`: [Token](../enums/_types_.token.md), `sellAmount`: string): *Promise‹string›*

*Defined in [dether.ts:163](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L163)*

**Parameters:**

Name | Type |
------ | ------ |
`sellToken` | [Token](../enums/_types_.token.md) |
`buyToken` | [Token](../enums/_types_.token.md) |
`sellAmount` | string |

**Returns:** *Promise‹string›*

___

###  getLicencePriceInZone

▸ **getLicencePriceInZone**(`geohash6`: string): *Promise‹string›*

*Defined in [dether.ts:439](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L439)*

**Parameters:**

Name | Type |
------ | ------ |
`geohash6` | string |

**Returns:** *Promise‹string›*

___

###  getOpenBid

▸ **getOpenBid**(`address`: string): *Promise‹any›*

*Defined in [dether.ts:812](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L812)*

**Parameters:**

Name | Type |
------ | ------ |
`address` | string |

**Returns:** *Promise‹any›*

___

###  getShopByAddress

▸ **getShopByAddress**(`shopAddress`: string): *Promise‹[IShop](../interfaces/_types_.ishop.md)›*

*Defined in [dether.ts:418](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L418)*

**Parameters:**

Name | Type |
------ | ------ |
`shopAddress` | string |

**Returns:** *Promise‹[IShop](../interfaces/_types_.ishop.md)›*

___

###  getShopByPosition

▸ **getShopByPosition**(`geohash12`: string): *Promise‹[IShop](../interfaces/_types_.ishop.md)›*

*Defined in [dether.ts:423](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L423)*

**Parameters:**

Name | Type |
------ | ------ |
`geohash12` | string |

**Returns:** *Promise‹[IShop](../interfaces/_types_.ishop.md)›*

___

###  getShopsInZone

▸ **getShopsInZone**(`geohash6`: string): *Promise‹[IShop](../interfaces/_types_.ishop.md)[]›*

*Defined in [dether.ts:428](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L428)*

**Parameters:**

Name | Type |
------ | ------ |
`geohash6` | string |

**Returns:** *Promise‹[IShop](../interfaces/_types_.ishop.md)[]›*

___

###  getShopsInZones

▸ **getShopsInZones**(`geohash6List`: string[]): *Promise‹[IShop](../interfaces/_types_.ishop.md)[][]›*

*Defined in [dether.ts:434](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L434)*

**Parameters:**

Name | Type |
------ | ------ |
`geohash6List` | string[] |

**Returns:** *Promise‹[IShop](../interfaces/_types_.ishop.md)[][]›*

___

###  getTeller

▸ **getTeller**(`address`: string): *Promise‹any›*

*Defined in [dether.ts:319](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L319)*

**Parameters:**

Name | Type |
------ | ------ |
`address` | string |

**Returns:** *Promise‹any›*

___

###  getTellerInZone

▸ **getTellerInZone**(`geohash6`: string): *Promise‹any›*

*Defined in [dether.ts:324](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L324)*

**Parameters:**

Name | Type |
------ | ------ |
`geohash6` | string |

**Returns:** *Promise‹any›*

___

###  getTellersInZones

▸ **getTellersInZones**(`geohash6List`: string[]): *Promise‹any[]›*

*Defined in [dether.ts:333](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L333)*

**Parameters:**

Name | Type |
------ | ------ |
`geohash6List` | string[] |

**Returns:** *Promise‹any[]›*

___

###  getTokenLiquidity

▸ **getTokenLiquidity**(`tokenAddress`: string, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹any›*

*Defined in [dether.ts:303](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L303)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`tokenAddress` | string | - |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) | constants.DEFAULT_TX_OPTIONS |

**Returns:** *Promise‹any›*

___

###  getTransactionStatus

▸ **getTransactionStatus**(`txHash`: string): *Promise‹[TransactionStatus](../enums/_types_.transactionstatus.md)›*

*Defined in [dether.ts:820](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L820)*

**Parameters:**

Name | Type |
------ | ------ |
`txHash` | string |

**Returns:** *Promise‹[TransactionStatus](../enums/_types_.transactionstatus.md)›*

___

###  getZoneByAddress

▸ **getZoneByAddress**(`address`: string): *Promise‹[IZone](../interfaces/_types_.izone.md)›*

*Defined in [dether.ts:567](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L567)*

**Parameters:**

Name | Type |
------ | ------ |
`address` | string |

**Returns:** *Promise‹[IZone](../interfaces/_types_.izone.md)›*

___

###  getZoneByGeohash

▸ **getZoneByGeohash**(`geohash6`: string): *Promise‹[IZone](../interfaces/_types_.izone.md)›*

*Defined in [dether.ts:558](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L558)*

**Parameters:**

Name | Type |
------ | ------ |
`geohash6` | string |

**Returns:** *Promise‹[IZone](../interfaces/_types_.izone.md)›*

___

###  getZonesStatus

▸ **getZonesStatus**(`geohash6List`: string[]): *Promise‹any[]›*

*Defined in [dether.ts:572](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L572)*

**Parameters:**

Name | Type |
------ | ------ |
`geohash6List` | string[] |

**Returns:** *Promise‹any[]›*

___

###  hasApproval

▸ **hasApproval**(`owner`: string, `sellToken`: [Token](../enums/_types_.token.md), `amount`: string): *Promise‹boolean›*

*Defined in [dether.ts:177](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L177)*

**Parameters:**

Name | Type |
------ | ------ |
`owner` | string |
`sellToken` | [Token](../enums/_types_.token.md) |
`amount` | string |

**Returns:** *Promise‹boolean›*

___

### `Private` hasProvider

▸ **hasProvider**(): *void*

*Defined in [dether.ts:137](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L137)*

**Returns:** *void*

___

### `Private` hasWallet

▸ **hasWallet**(): *void*

*Defined in [dether.ts:142](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L142)*

**Returns:** *void*

___

###  init

▸ **init**(`connectOptions?`: [IEthersOptions](../interfaces/_types_.iethersoptions.md)): *Promise‹void›*

*Defined in [dether.ts:55](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L55)*

**Parameters:**

Name | Type |
------ | ------ |
`connectOptions?` | [IEthersOptions](../interfaces/_types_.iethersoptions.md) |

**Returns:** *Promise‹void›*

___

###  initProvider

▸ **initProvider**(`connectOptions?`: [IEthersOptions](../interfaces/_types_.iethersoptions.md)): *Promise‹void›*

*Defined in [dether.ts:97](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L97)*

**Parameters:**

Name | Type |
------ | ------ |
`connectOptions?` | [IEthersOptions](../interfaces/_types_.iethersoptions.md) |

**Returns:** *Promise‹void›*

___

###  isBidderOnthisAuction

▸ **isBidderOnthisAuction**(`zoneAddress`: string, `ethAddress`: string, `auctionID`: number): *Promise‹number›*

*Defined in [dether.ts:581](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L581)*

**Parameters:**

Name | Type |
------ | ------ |
`zoneAddress` | string |
`ethAddress` | string |
`auctionID` | number |

**Returns:** *Promise‹number›*

___

###  isTeller

▸ **isTeller**(`address`: string): *Promise‹any›*

*Defined in [dether.ts:314](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L314)*

**Parameters:**

Name | Type |
------ | ------ |
`address` | string |

**Returns:** *Promise‹any›*

___

###  isZoneOpened

▸ **isZoneOpened**(`geohash6`: string, `country`: string): *Promise‹Boolean›*

*Defined in [dether.ts:802](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L802)*

**Parameters:**

Name | Type |
------ | ------ |
`geohash6` | string |
`country` | string |

**Returns:** *Promise‹Boolean›*

___

###  isZoneOwned

▸ **isZoneOwned**(`geohash6`: string): *Promise‹Boolean›*

*Defined in [dether.ts:553](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L553)*

**Parameters:**

Name | Type |
------ | ------ |
`geohash6` | string |

**Returns:** *Promise‹Boolean›*

___

###  isZoneOwner

▸ **isZoneOwner**(`address`: string): *Promise‹any›*

*Defined in [dether.ts:807](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L807)*

**Parameters:**

Name | Type |
------ | ------ |
`address` | string |

**Returns:** *Promise‹any›*

___

###  loadUser

▸ **loadUser**(`encryptedWallet`: string): *void*

*Defined in [dether.ts:104](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L104)*

**Parameters:**

Name | Type |
------ | ------ |
`encryptedWallet` | string |

**Returns:** *void*

___

### `Private` loadWallet

▸ **loadWallet**(`password?`: string): *Promise‹Wallet›*

*Defined in [dether.ts:112](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L112)*

**Parameters:**

Name | Type |
------ | ------ |
`password?` | string |

**Returns:** *Promise‹Wallet›*

___

###  processState

▸ **processState**(`password`: string, `zoneAddress`: string, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [dether.ts:791](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L791)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`password` | string | - |
`zoneAddress` | string | - |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) | constants.DEFAULT_TX_OPTIONS |

**Returns:** *Promise‹ContractTransaction›*

___

###  releaseZone

▸ **releaseZone**(`password`: string, `geohash6`: string, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [dether.ts:671](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L671)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`password` | string | - |
`geohash6` | string | - |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) | constants.DEFAULT_TX_OPTIONS |

**Returns:** *Promise‹ContractTransaction›*

___

###  removeShop

▸ **removeShop**(`password`: string, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [dether.ts:462](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L462)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`password` | string | - |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) | constants.DEFAULT_TX_OPTIONS |

**Returns:** *Promise‹ContractTransaction›*

___

###  removeTeller

▸ **removeTeller**(`password`: string, `zoneGeohash`: string, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [dether.ts:359](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L359)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`password` | string | - |
`zoneGeohash` | string | - |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) | constants.DEFAULT_TX_OPTIONS |

**Returns:** *Promise‹ContractTransaction›*

___

###  sendCrypto

▸ **sendCrypto**(`password`: string, `toAddress`: string, `token`: [Token](../enums/_types_.token.md), `amount`: string, `tokenAddress`: string, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [dether.ts:264](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L264)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`password` | string | - |
`toAddress` | string | - |
`token` | [Token](../enums/_types_.token.md) | - |
`amount` | string | - |
`tokenAddress` | string | constants.ADDRESS_ZERO |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) | constants.DEFAULT_TX_OPTIONS |

**Returns:** *Promise‹ContractTransaction›*

___

###  setCustomContractAddresses

▸ **setCustomContractAddresses**(`contractAddresses`: any): *Promise‹void›*

*Defined in [dether.ts:81](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L81)*

**Parameters:**

Name | Type |
------ | ------ |
`contractAddresses` | any |

**Returns:** *Promise‹void›*

___

###  setShopLicencePrice

▸ **setShopLicencePrice**(`password`: string, `geohash6`: string, `newPrice`: string, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [dether.ts:472](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L472)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`password` | string | - |
`geohash6` | string | - |
`newPrice` | string | - |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) | constants.DEFAULT_TX_OPTIONS |

**Returns:** *Promise‹ContractTransaction›*

___

###  shopExistsByAddress

▸ **shopExistsByAddress**(`shopAddress`: string): *Promise‹boolean›*

*Defined in [dether.ts:413](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L413)*

**Parameters:**

Name | Type |
------ | ------ |
`shopAddress` | string |

**Returns:** *Promise‹boolean›*

___

###  signMessage

▸ **signMessage**(`password`: string, `message`: string): *Promise‹string›*

*Defined in [dether.ts:285](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L285)*

**Parameters:**

Name | Type |
------ | ------ |
`password` | string |
`message` | string |

**Returns:** *Promise‹string›*

___

###  topUpShop

▸ **topUpShop**(`password`: string, `topUpAmount`: string, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [dether.ts:490](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L490)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`password` | string | - |
`topUpAmount` | string | - |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) | constants.DEFAULT_TX_OPTIONS |

**Returns:** *Promise‹ContractTransaction›*

___

###  topUpZone

▸ **topUpZone**(`password`: string, `geohash6`: string, `topUpAmount`: string, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [dether.ts:652](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L652)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`password` | string | - |
`geohash6` | string | - |
`topUpAmount` | string | - |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) | constants.DEFAULT_TX_OPTIONS |

**Returns:** *Promise‹ContractTransaction›*

___

###  updateTeller

▸ **updateTeller**(`password`: string, `tellerData`: [ITellerArgs](../interfaces/_types_.itellerargs.md), `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [dether.ts:375](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L375)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`password` | string | - |
`tellerData` | [ITellerArgs](../interfaces/_types_.itellerargs.md) | - |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) | constants.DEFAULT_TX_OPTIONS |

**Returns:** *Promise‹ContractTransaction›*

___

###  withdrawAuctionsRaw

▸ **withdrawAuctionsRaw**(`password`: string, `zoneAddress`: string, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [dether.ts:751](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L751)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`password` | string | - |
`zoneAddress` | string | - |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) | constants.DEFAULT_TX_OPTIONS |

**Returns:** *Promise‹ContractTransaction›*

___

###  withdrawZoneAuctionBid

▸ **withdrawZoneAuctionBid**(`password`: string, `geohash6`: string, `auctionId`: number, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [dether.ts:682](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L682)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`password` | string | - |
`geohash6` | string | - |
`auctionId` | number | - |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) | constants.DEFAULT_TX_OPTIONS |

**Returns:** *Promise‹ContractTransaction›*

___

###  withdrawZoneAuctionBidAddress

▸ **withdrawZoneAuctionBidAddress**(`password`: string, `zoneAddress`: string, `auctionId`: number, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [dether.ts:734](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L734)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`password` | string | - |
`zoneAddress` | string | - |
`auctionId` | number | - |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) | constants.DEFAULT_TX_OPTIONS |

**Returns:** *Promise‹ContractTransaction›*

___

###  withdrawZoneAuctionsBid

▸ **withdrawZoneAuctionsBid**(`password`: string, `geohash6`: string, `auctionIds`: number[], `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [dether.ts:700](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L700)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`password` | string | - |
`geohash6` | string | - |
`auctionIds` | number[] | - |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) | constants.DEFAULT_TX_OPTIONS |

**Returns:** *Promise‹ContractTransaction›*

___

###  withdrawZoneAuctionsBidAddress

▸ **withdrawZoneAuctionsBidAddress**(`password`: string, `zoneAddress`: string, `auctionIds`: number[], `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [dether.ts:763](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L763)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`password` | string | - |
`zoneAddress` | string | - |
`auctionIds` | number[] | - |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) | constants.DEFAULT_TX_OPTIONS |

**Returns:** *Promise‹ContractTransaction›*

___

###  withdrawZoneOwnerDth

▸ **withdrawZoneOwnerDth**(`password`: string, `geohash6`: string, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [dether.ts:718](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L718)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`password` | string | - |
`geohash6` | string | - |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) | constants.DEFAULT_TX_OPTIONS |

**Returns:** *Promise‹ContractTransaction›*

___

###  withdrawZoneOwnerDthAddress

▸ **withdrawZoneOwnerDthAddress**(`password`: string, `zoneAddress`: string, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [dether.ts:780](https://github.com/dethertech/detherJS/blob/34cf05e/src/dether.ts#L780)*

**Parameters:**

Name | Type | Default |
------ | ------ | ------ |
`password` | string | - |
`zoneAddress` | string | - |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) | constants.DEFAULT_TX_OPTIONS |

**Returns:** *Promise‹ContractTransaction›*
