[detherjs](../README.md) › [Globals](../globals.md) › ["constants"](_constants_.md)

# Module: "constants"

## Index

### Variables

* [ADDRESS_BURN](_constants_.md#const-address_burn)
* [ADDRESS_ZERO](_constants_.md#const-address_zero)
* [BYTES12_ZERO](_constants_.md#const-bytes12_zero)
* [BYTES16_ZERO](_constants_.md#const-bytes16_zero)
* [BYTES1_ZERO](_constants_.md#const-bytes1_zero)
* [BYTES32_ZERO](_constants_.md#const-bytes32_zero)
* [BYTES7_ZERO](_constants_.md#const-bytes7_zero)
* [COORD_PRECISION](_constants_.md#const-coord_precision)
* [CRYPTOCOMPARE_URL](_constants_.md#const-cryptocompare_url)
* [ERC223_TRANSFER_ABI](_constants_.md#const-erc223_transfer_abi)
* [EXCHANGE_PAIRS](_constants_.md#const-exchange_pairs)
* [GAS_PRICE](_constants_.md#const-gas_price)
* [MIN_ZONE_STAKE](_constants_.md#const-min_zone_stake)

### Object literals

* [CONTRACT_ADDRESSES](_constants_.md#const-contract_addresses)
* [DEFAULT_TX_OPTIONS](_constants_.md#const-default_tx_options)
* [TICKER](_constants_.md#const-ticker)

## Variables

### `Const` ADDRESS_BURN

• **ADDRESS_BURN**: *"0xffffffffffffffffffffffffffffffffffffffff"* = "0xffffffffffffffffffffffffffffffffffffffff"

*Defined in [constants.ts:179](https://github.com/dethertech/detherJS/blob/34cf05e/src/constants.ts#L179)*

___

### `Const` ADDRESS_ZERO

• **ADDRESS_ZERO**: *"0x0000000000000000000000000000000000000000"* = "0x0000000000000000000000000000000000000000"

*Defined in [constants.ts:178](https://github.com/dethertech/detherJS/blob/34cf05e/src/constants.ts#L178)*

___

### `Const` BYTES12_ZERO

• **BYTES12_ZERO**: *"0x000000000000000000000000"* = "0x000000000000000000000000"

*Defined in [constants.ts:174](https://github.com/dethertech/detherJS/blob/34cf05e/src/constants.ts#L174)*

___

### `Const` BYTES16_ZERO

• **BYTES16_ZERO**: *"0x00000000000000000000000000000000"* = "0x00000000000000000000000000000000"

*Defined in [constants.ts:175](https://github.com/dethertech/detherJS/blob/34cf05e/src/constants.ts#L175)*

___

### `Const` BYTES1_ZERO

• **BYTES1_ZERO**: *"0x00"* = "0x00"

*Defined in [constants.ts:172](https://github.com/dethertech/detherJS/blob/34cf05e/src/constants.ts#L172)*

___

### `Const` BYTES32_ZERO

• **BYTES32_ZERO**: *"0x0000000000000000000000000000000000000000000000000000000000000000"* = "0x0000000000000000000000000000000000000000000000000000000000000000"

*Defined in [constants.ts:176](https://github.com/dethertech/detherJS/blob/34cf05e/src/constants.ts#L176)*

___

### `Const` BYTES7_ZERO

• **BYTES7_ZERO**: *"0x00000000000000"* = "0x00000000000000"

*Defined in [constants.ts:173](https://github.com/dethertech/detherJS/blob/34cf05e/src/constants.ts#L173)*

___

### `Const` COORD_PRECISION

• **COORD_PRECISION**: *number* = 5

*Defined in [constants.ts:7](https://github.com/dethertech/detherJS/blob/34cf05e/src/constants.ts#L7)*

___

### `Const` CRYPTOCOMPARE_URL

• **CRYPTOCOMPARE_URL**: *string* = "https://min-api.cryptocompare.com/"

*Defined in [constants.ts:3](https://github.com/dethertech/detherJS/blob/34cf05e/src/constants.ts#L3)*

___

### `Const` ERC223_TRANSFER_ABI

• **ERC223_TRANSFER_ABI**: *"function transfer(address _to, uint _value, bytes _data) returns (bool)"* = "function transfer(address _to, uint _value, bytes _data) returns (bool)"

*Defined in [constants.ts:169](https://github.com/dethertech/detherJS/blob/34cf05e/src/constants.ts#L169)*

___

### `Const` EXCHANGE_PAIRS

• **EXCHANGE_PAIRS**: *[IExchangePair](../interfaces/_types_.iexchangepair.md)[]* = [
  { tokens: [Token.ETH, Token.DTH], exchange: Exchange.kyber },
  { tokens: [Token.ETH, Token.DAI], exchange: Exchange.uniswap },
  { tokens: [Token.ETH, Token.BNB], exchange: Exchange.kyber },
  { tokens: [Token.ETH, Token.MKR], exchange: Exchange.uniswap },
  { tokens: [Token.ETH, Token.OMG], exchange: Exchange.kyber },
  { tokens: [Token.ETH, Token.ZRX], exchange: Exchange.kyber },
  { tokens: [Token.ETH, Token.VEN], exchange: Exchange.kyber },
  { tokens: [Token.ETH, Token.AE], exchange: Exchange.kyber },
  { tokens: [Token.ETH, Token.REP], exchange: Exchange.kyber },
  { tokens: [Token.ETH, Token.KNC], exchange: Exchange.kyber }
]

*Defined in [constants.ts:57](https://github.com/dethertech/detherJS/blob/34cf05e/src/constants.ts#L57)*

___

### `Const` GAS_PRICE

• **GAS_PRICE**: *number* = 25000000000

*Defined in [constants.ts:5](https://github.com/dethertech/detherJS/blob/34cf05e/src/constants.ts#L5)*

___

### `Const` MIN_ZONE_STAKE

• **MIN_ZONE_STAKE**: *100* = 100

*Defined in [constants.ts:162](https://github.com/dethertech/detherJS/blob/34cf05e/src/constants.ts#L162)*

## Object literals

### `Const` CONTRACT_ADDRESSES

### ▪ **CONTRACT_ADDRESSES**: *object*

*Defined in [constants.ts:71](https://github.com/dethertech/detherJS/blob/34cf05e/src/constants.ts#L71)*

▪ **custom**: *object*

*Defined in [constants.ts:143](https://github.com/dethertech/detherJS/blob/34cf05e/src/constants.ts#L143)*

* **CertifierRegistry**: *string* = ""

* **Control**: *string* = ""

* **DetherToken**: *string* = ""

* **GeoRegistry**: *string* = ""

* **KycCertifier**: *string* = ""

* **Shops**: *string* = ""

* **SmsCertifier**: *string* = ""

* **TokenRegistry**: *string* = ""

* **Users**: *string* = ""

* **Zone**: *string* = ""

* **ZoneFactory**: *string* = ""

* **kyberNetworkProxy**: *string* = ""

* **uniswapExchange**: *string* = ""

▪ **homestead**: *object*

*Defined in [constants.ts:127](https://github.com/dethertech/detherJS/blob/34cf05e/src/constants.ts#L127)*

* **CertifierRegistry**: *string* = "0xd8dCc8a6260A7EadC092B888A19d37EDe29107d7"

* **DetherToken**: *string* = "0x5adc961D6AC3f7062D2eA45FEFB8D8167d44b190"

* **GeoRegistry**: *string* = "0x782656D81861C1d23f28b64343a0e9656a6Ce453"

* **Shops**: *string* = "0x9aF46E1015235901832F9D46D042b68f32b1F458"

* **TaxCollector**: *string* = "0xb52221f5b11bc6b069151108336fcf6c6c91CF89"

* **TokenRegistry**: *string* = "0x8fc724457b8a3f156E93E058fc984c1c8c3BBdBa"

* **Users**: *string* = "0x3fb022DA091260b8588764F3FAdA3aAC16322B3A"

* **Zone**: *string* = "0xA1663482320767D612c024923dc7C82Eb6e3f92F"

* **ZoneFactory**: *string* = "0x27Df74Bb2B57546DACC38ADC548F5aB1CE18Cc9e"

* **kyberNetworkProxy**: *string* = "0x818E6FECD516Ecc3849DAf6845e3EC868087B755"

* **uniswapExchange**: *string* = ""

* **uniswapFactory**: *string* = "0xc0a47dFe034B400B47bDaD5FecDa2621de6c4d95"

▪ **kovan**: *object*

*Defined in [constants.ts:91](https://github.com/dethertech/detherJS/blob/34cf05e/src/constants.ts#L91)*

* **CertifierRegistry**: *string* = "0x7E2050E45433005EaD5Af5b4A9bb678603da04DC"

* **DetherToken**: *string* = "0x9027e9fc4641e2991a36eaeb0347bc5b35322741"

* **GeoRegistry**: *string* = "0xf60Aa1a0895bded3C116F4a6A94D179dc114b130"

* **Shops**: *string* = "0x09474a91745db50d0343e742DaEf91876DA7AC3c"

* **TaxCollector**: *string* = "0xDD4Bb064d43E119323B74bc84D26CC1CEB712eA9"

* **TokenRegistry**: *string* = "0x2d46f2742ceDF4D425C4A45f3649E877bA8a1105"

* **Users**: *string* = "0x86B4f88f066d96d18A8B062F487FF32278f18126"

* **Zone**: *string* = "0xAFC085b6651EA78A12b1eE2c45c1C20d61097168"

* **ZoneFactory**: *string* = "0x2C3EAea2ae987eCDd2993BC1Af97561161BA4f22"

* **kyberNetworkProxy**: *string* = "0x7e6b8b9510D71BF8EF0f893902EbB9C865eEF4Df"

* **uniswapExchange**: *string* = ""

* **uniswapFactory**: *string* = "0xD3E51Ef092B2845f10401a0159B2B96e8B6c3D30"

▪ **rinkeby**: *object*

*Defined in [constants.ts:109](https://github.com/dethertech/detherJS/blob/34cf05e/src/constants.ts#L109)*

* **CertifierRegistry**: *string* = ""

* **Control**: *string* = ""

* **DetherToken**: *string* = ""

* **GeoRegistry**: *string* = ""

* **KycCertifier**: *string* = ""

* **Shops**: *string* = ""

* **SmsCertifier**: *string* = ""

* **TokenRegistry**: *string* = ""

* **Users**: *string* = ""

* **Zone**: *string* = ""

* **ZoneFactory**: *string* = ""

* **airswapExchange**: *string* = "0x07fc7c43d8168a2730344e5cf958aaecc3b42b41"

* **uniswapExchange**: *string* = ""

▪ **ropsten**: *object*

*Defined in [constants.ts:72](https://github.com/dethertech/detherJS/blob/34cf05e/src/constants.ts#L72)*

* **CertifierRegistry**: *string* = ""

* **Control**: *string* = ""

* **DetherToken**: *string* = ""

* **GeoRegistry**: *string* = ""

* **KycCertifier**: *string* = ""

* **Shops**: *string* = ""

* **SmsCertifier**: *string* = ""

* **TokenRegistry**: *string* = ""

* **Users**: *string* = ""

* **Zone**: *string* = ""

* **ZoneFactory**: *string* = ""

* **kyberNetworkProxy**: *string* = "0x818E6FECD516Ecc3849DAf6845e3EC868087B755"

* **uniswapExchange**: *string* = ""

___

### `Const` DEFAULT_TX_OPTIONS

### ▪ **DEFAULT_TX_OPTIONS**: *object*

*Defined in [constants.ts:164](https://github.com/dethertech/detherJS/blob/34cf05e/src/constants.ts#L164)*

###  gasLimit

• **gasLimit**: *number* = 7000000

*Defined in [constants.ts:166](https://github.com/dethertech/detherJS/blob/34cf05e/src/constants.ts#L166)*

###  gasPrice

• **gasPrice**: *number* = 20000000000

*Defined in [constants.ts:165](https://github.com/dethertech/detherJS/blob/34cf05e/src/constants.ts#L165)*

___

### `Const` TICKER

### ▪ **TICKER**: *object*

*Defined in [constants.ts:9](https://github.com/dethertech/detherJS/blob/34cf05e/src/constants.ts#L9)*

▪ **custom**: *object*

*Defined in [constants.ts:52](https://github.com/dethertech/detherJS/blob/34cf05e/src/constants.ts#L52)*

* **DTH**: *string* = ""

▪ **homestead**: *object*

*Defined in [constants.ts:33](https://github.com/dethertech/detherJS/blob/34cf05e/src/constants.ts#L33)*

* **AE**: *string* = "0x5ca9a71b1d01849c0a95490cc00559717fcf0d1d"

* **BNB**: *string* = "0xb8c77482e45f1f44de1745f52c74426c631bdd52"

* **CAN**: *string* = "0x1d462414fe14cf489c7a21cac78509f4bf8cd7c0"

* **DAI**: *string* = "0x89d24a6b4ccb1b6faa2625fe562bdd9a23260359"

* **DTH**: *string* = "0x5adc961d6ac3f7062d2ea45fefb8d8167d44b190"

* **FLIXX**: *string* = "0xf04a8ac553fcedb5ba99a64799155826c136b0be"

* **HAV**: *string* = "0xc011a72400e58ecd99ee497cf89e3775d4bd732f"

* **KNC**: *string* = "0xdd974d5c2e2928dea5f71b9825b8b646686bd200"

* **MKR**: *string* = "0x9f8f72aa9304c8b593d555f12ef6589cc3a579a2"

* **NUSD**: *string* = "0x57ab1e02fee23774580c119740129eac7081e9d3"

* **OMG**: *string* = "0xd26114cd6ee289accf82350c8d8487fedb8a0c07"

* **PNK**: *string* = "0x93ed3fbe21207ec2e8f2d3c3de6e058cb73bc04d"

* **REP**: *string* = "0xe94327d07fc17907b4db788e5adf2ed424addff6"

* **VEN**: *string* = "0xd850942ef8811f2a866692a623011bde52a462c1"

* **WETH**: *string* = "0xc02aaa39b223fe8d0a0e5c4f27ead9083c756cc2"

* **ZLA**: *string* = "0xfd8971d5e8e1740ce2d0a84095fca4de729d0c16"

* **ZRX**: *string* = "0xe41d2489571d322189246dafa5ebde1f4699f498"

▪ **kovan**: *object*

*Defined in [constants.ts:10](https://github.com/dethertech/detherJS/blob/34cf05e/src/constants.ts#L10)*

* **DAI**: *string* = "0x4C38cDC08f1260F5c4b21685654393BB1e66a858"

* **DGD**: *string* = "0xeee3870657e4716670f185df08652dd848fe8f7e"

* **DTH**: *string* = "0x9027E9FC4641e2991A36Eaeb0347Bc5b35322741"

* **GNT**: *string* = "0xef7fff64389b814a946f3e92105513705ca6b990"

* **KNC**: *string* = "0xB2f3dD487708ca7794f633D9Df57Fdb9347a7afF"

* **MKR**: *string* = "0xaC94Ea989f6955C67200DD67F0101e1865A560Ea"

* **POLY**: *string* = "0xB06d72a24df50D4E2cAC133B320c5E7DE3ef94cB"

* **REP**: *string* = "0x4c7493B70F16beC1e087Bf74a31D095F9B8f9c40"

* **USDC**: *string* = "0x381a4c615df73c912f98c7b528fc415186cb69ea"

* **WETH**: *string* = "0xd0A1E359811322d97991E03f863a0C30C2cF029C"

▪ **rinkeby**: *object*

*Defined in [constants.ts:29](https://github.com/dethertech/detherJS/blob/34cf05e/src/constants.ts#L29)*

* **DTH**: *string* = "0xaaa5dd9beff81bb47ccdde852504fb94fa18415c"

* **WETH**: *string* = "0xc778417e063141139fce010982780140aa0cd5ab"

▪ **ropsten**: *object*

*Defined in [constants.ts:23](https://github.com/dethertech/detherJS/blob/34cf05e/src/constants.ts#L23)*

* **DAI**: *string* = "0xaD6D458402F60fD3Bd25163575031ACDce07538D"

* **DTH**: *string* = "0xdb06f28e163684de611f21f76203e42ab4ae5b55"

* **OMG**: *string* = "0x4BFBa4a8F28755Cb2061c413459EE562c6B9c51b"

* **WETH**: *string* = "0x0000000000000000000000000000000000000000"
