[detherjs](../README.md) › [Globals](../globals.md) › ["core/shop"](_core_shop_.md)

# Module: "core/shop"

## Index

### Variables

* [SHOP_ADD_FN](_core_shop_.md#const-shop_add_fn)

### Functions

* [addShop](_core_shop_.md#const-addshop)
* [collectShopTaxes](_core_shop_.md#const-collectshoptaxes)
* [createShopBytes](_core_shop_.md#const-createshopbytes)
* [createShopTopUpBytes](_core_shop_.md#const-createshoptopupbytes)
* [deleteUserShop](_core_shop_.md#const-deleteusershop)
* [existsByAddress](_core_shop_.md#const-existsbyaddress)
* [getLicencePrice](_core_shop_.md#const-getlicenceprice)
* [getShopByAddress](_core_shop_.md#const-getshopbyaddress)
* [getShopByPosition](_core_shop_.md#const-getshopbyposition)
* [getShopsInZone](_core_shop_.md#const-getshopsinzone)
* [getShopsInZones](_core_shop_.md#const-getshopsinzones)
* [removeShop](_core_shop_.md#const-removeshop)
* [setShopLicencePrice](_core_shop_.md#const-setshoplicenceprice)
* [shopArrToObj](_core_shop_.md#const-shoparrtoobj)
* [topUpShop](_core_shop_.md#const-topupshop)

## Variables

### `Const` SHOP_ADD_FN

• **SHOP_ADD_FN**: *"30"* = "30"

*Defined in [core/shop.ts:12](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/shop.ts#L12)*

## Functions

### `Const` addShop

▸ **addShop**(`shopData`: [IShopArgs](../interfaces/_types_.ishopargs.md), `shopContract`: Contract, `detherTokenContract`: Contract, `wallet`: Wallet, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [core/shop.ts:222](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/shop.ts#L222)*

**Parameters:**

Name | Type |
------ | ------ |
`shopData` | [IShopArgs](../interfaces/_types_.ishopargs.md) |
`shopContract` | Contract |
`detherTokenContract` | Contract |
`wallet` | Wallet |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction›*

___

### `Const` collectShopTaxes

▸ **collectShopTaxes**(`geohash6`: string, `start`: number, `end`: number, `shopContract`: Contract, `wallet`: Wallet, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [core/shop.ts:285](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/shop.ts#L285)*

**Parameters:**

Name | Type |
------ | ------ |
`geohash6` | string |
`start` | number |
`end` | number |
`shopContract` | Contract |
`wallet` | Wallet |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction›*

___

### `Const` createShopBytes

▸ **createShopBytes**(`shopData`: [IShopArgs](../interfaces/_types_.ishopargs.md)): *string*

*Defined in [core/shop.ts:94](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/shop.ts#L94)*

**Parameters:**

Name | Type |
------ | ------ |
`shopData` | [IShopArgs](../interfaces/_types_.ishopargs.md) |

**Returns:** *string*

___

### `Const` createShopTopUpBytes

▸ **createShopTopUpBytes**(): *string*

*Defined in [core/shop.ts:117](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/shop.ts#L117)*

**Returns:** *string*

___

### `Const` deleteUserShop

▸ **deleteUserShop**(`geohash6`: string, `shopAddress`: string, `shopContract`: Contract, `wallet`: Wallet, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [core/shop.ts:298](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/shop.ts#L298)*

**Parameters:**

Name | Type |
------ | ------ |
`geohash6` | string |
`shopAddress` | string |
`shopContract` | Contract |
`wallet` | Wallet |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction›*

___

### `Const` existsByAddress

▸ **existsByAddress**(`shopAddress`: string, `shopInstance`: Contract): *Promise‹boolean›*

*Defined in [core/shop.ts:125](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/shop.ts#L125)*

**Parameters:**

Name | Type |
------ | ------ |
`shopAddress` | string |
`shopInstance` | Contract |

**Returns:** *Promise‹boolean›*

___

### `Const` getLicencePrice

▸ **getLicencePrice**(`geohash6`: string, `shopInstance`: Contract): *Promise‹any›*

*Defined in [core/shop.ts:136](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/shop.ts#L136)*

**Parameters:**

Name | Type |
------ | ------ |
`geohash6` | string |
`shopInstance` | Contract |

**Returns:** *Promise‹any›*

___

### `Const` getShopByAddress

▸ **getShopByAddress**(`shopAddress`: string, `shopInstance`: Contract): *Promise‹[IShop](../interfaces/_types_.ishop.md)›*

*Defined in [core/shop.ts:157](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/shop.ts#L157)*

**Parameters:**

Name | Type |
------ | ------ |
`shopAddress` | string |
`shopInstance` | Contract |

**Returns:** *Promise‹[IShop](../interfaces/_types_.ishop.md)›*

___

### `Const` getShopByPosition

▸ **getShopByPosition**(`geohash12`: string, `shopInstance`: Contract): *Promise‹[IShop](../interfaces/_types_.ishop.md)›*

*Defined in [core/shop.ts:175](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/shop.ts#L175)*

**Parameters:**

Name | Type |
------ | ------ |
`geohash12` | string |
`shopInstance` | Contract |

**Returns:** *Promise‹[IShop](../interfaces/_types_.ishop.md)›*

___

### `Const` getShopsInZone

▸ **getShopsInZone**(`geohash6`: string, `shopInstance`: Contract): *Promise‹[IShop](../interfaces/_types_.ishop.md)[]›*

*Defined in [core/shop.ts:189](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/shop.ts#L189)*

**Parameters:**

Name | Type |
------ | ------ |
`geohash6` | string |
`shopInstance` | Contract |

**Returns:** *Promise‹[IShop](../interfaces/_types_.ishop.md)[]›*

___

### `Const` getShopsInZones

▸ **getShopsInZones**(`geohash6List`: string[], `shopInstance`: Contract): *Promise‹[IShop](../interfaces/_types_.ishop.md)[][]›*

*Defined in [core/shop.ts:206](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/shop.ts#L206)*

**Parameters:**

Name | Type |
------ | ------ |
`geohash6List` | string[] |
`shopInstance` | Contract |

**Returns:** *Promise‹[IShop](../interfaces/_types_.ishop.md)[][]›*

___

### `Const` removeShop

▸ **removeShop**(`shopContract`: Contract, `wallet`: Wallet, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [core/shop.ts:244](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/shop.ts#L244)*

**Parameters:**

Name | Type |
------ | ------ |
`shopContract` | Contract |
`wallet` | Wallet |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction›*

___

### `Const` setShopLicencePrice

▸ **setShopLicencePrice**(`geohash6`: string, `newPrice`: string, `shopContract`: Contract, `wallet`: Wallet, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [core/shop.ts:269](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/shop.ts#L269)*

**Parameters:**

Name | Type |
------ | ------ |
`geohash6` | string |
`newPrice` | string |
`shopContract` | Contract |
`wallet` | Wallet |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction›*

___

### `Const` shopArrToObj

▸ **shopArrToObj**(`shopArr`: any[]): *[IShop](../interfaces/_types_.ishop.md)*

*Defined in [core/shop.ts:18](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/shop.ts#L18)*

**Parameters:**

Name | Type |
------ | ------ |
`shopArr` | any[] |

**Returns:** *[IShop](../interfaces/_types_.ishop.md)*

___

### `Const` topUpShop

▸ **topUpShop**(`topUpAmount`: string, `shopContract`: Contract, `detherTokenContract`: Contract, `wallet`: Wallet, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [core/shop.ts:254](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/shop.ts#L254)*

**Parameters:**

Name | Type |
------ | ------ |
`topUpAmount` | string |
`shopContract` | Contract |
`detherTokenContract` | Contract |
`wallet` | Wallet |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction›*
