[detherjs](../README.md) › [Globals](../globals.md) › ["core/teller"](_core_teller_.md)

# Module: "core/teller"

## Index

### Variables

* [EMPTY_MESSENGER_FIELD](_core_teller_.md#const-empty_messenger_field)

### Functions

* [addComment](_core_teller_.md#const-addcomment)
* [addFunds](_core_teller_.md#const-addfunds)
* [addTeller](_core_teller_.md#const-addteller)
* [getTeller](_core_teller_.md#const-getteller)
* [getTellerInZone](_core_teller_.md#const-gettellerinzone)
* [getTellersInZones](_core_teller_.md#const-gettellersinzones)
* [isTeller](_core_teller_.md#const-isteller)
* [removeTeller](_core_teller_.md#const-removeteller)
* [settingsToBytes](_core_teller_.md#const-settingstobytes)
* [tellerArrToObj](_core_teller_.md#const-tellerarrtoobj)
* [updateTeller](_core_teller_.md#const-updateteller)

## Variables

### `Const` EMPTY_MESSENGER_FIELD

• **EMPTY_MESSENGER_FIELD**: *"0x00000000000000000000000000000000"* = "0x00000000000000000000000000000000"

*Defined in [core/teller.ts:17](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/teller.ts#L17)*

## Functions

### `Const` addComment

▸ **addComment**(`zoneGeohash`: string, `ipfsHash`: string, `wallet`: Wallet, `zoneFactoryContract`: Contract, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [core/teller.ts:371](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/teller.ts#L371)*

**Parameters:**

Name | Type |
------ | ------ |
`zoneGeohash` | string |
`ipfsHash` | string |
`wallet` | Wallet |
`zoneFactoryContract` | Contract |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction›*

___

### `Const` addFunds

▸ **addFunds**(`zoneGeohash`: string, `ethAmount`: string, `wallet`: Wallet, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [core/teller.ts:335](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/teller.ts#L335)*

**Parameters:**

Name | Type |
------ | ------ |
`zoneGeohash` | string |
`ethAmount` | string |
`wallet` | Wallet |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction›*

___

### `Const` addTeller

▸ **addTeller**(`tellerData`: [ITellerArgs](../interfaces/_types_.itellerargs.md), `wallet`: Wallet, `zoneFactoryContract`: Contract, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [core/teller.ts:192](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/teller.ts#L192)*

**Parameters:**

Name | Type |
------ | ------ |
`tellerData` | [ITellerArgs](../interfaces/_types_.itellerargs.md) |
`wallet` | Wallet |
`zoneFactoryContract` | Contract |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction›*

___

### `Const` getTeller

▸ **getTeller**(`address`: string, `provider`: Provider, `zoneFactoryContract`: Contract): *Promise‹any›*

*Defined in [core/teller.ts:72](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/teller.ts#L72)*

**Parameters:**

Name | Type |
------ | ------ |
`address` | string |
`provider` | Provider |
`zoneFactoryContract` | Contract |

**Returns:** *Promise‹any›*

___

### `Const` getTellerInZone

▸ **getTellerInZone**(`geohash6`: string, `provider`: Provider, `zoneFactoryContract`: Contract): *Promise‹any›*

*Defined in [core/teller.ts:107](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/teller.ts#L107)*

**Parameters:**

Name | Type |
------ | ------ |
`geohash6` | string |
`provider` | Provider |
`zoneFactoryContract` | Contract |

**Returns:** *Promise‹any›*

___

### `Const` getTellersInZones

▸ **getTellersInZones**(`geohash6List`: string[], `provider`: Provider, `zoneFactoryContract`: Contract): *Promise‹any[]›*

*Defined in [core/teller.ts:140](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/teller.ts#L140)*

**Parameters:**

Name | Type |
------ | ------ |
`geohash6List` | string[] |
`provider` | Provider |
`zoneFactoryContract` | Contract |

**Returns:** *Promise‹any[]›*

___

### `Const` isTeller

▸ **isTeller**(`address`: string, `provider`: Provider, `zoneFactoryContract`: Contract): *Promise‹any›*

*Defined in [core/teller.ts:152](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/teller.ts#L152)*

**Parameters:**

Name | Type |
------ | ------ |
`address` | string |
`provider` | Provider |
`zoneFactoryContract` | Contract |

**Returns:** *Promise‹any›*

___

### `Const` removeTeller

▸ **removeTeller**(`zoneGeohash`: string, `wallet`: Wallet, `zoneFactoryContract`: Contract, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [core/teller.ts:309](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/teller.ts#L309)*

**Parameters:**

Name | Type |
------ | ------ |
`zoneGeohash` | string |
`wallet` | Wallet |
`zoneFactoryContract` | Contract |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction›*

___

### `Const` settingsToBytes

▸ **settingsToBytes**(`isBuyer`: boolean, `isSeller`: boolean): *string*

*Defined in [core/teller.ts:56](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/teller.ts#L56)*

**Parameters:**

Name | Type |
------ | ------ |
`isBuyer` | boolean |
`isSeller` | boolean |

**Returns:** *string*

___

### `Const` tellerArrToObj

▸ **tellerArrToObj**(`zoneAddr`: string, `tellerContractAddr`: string, `tellerArr`: any[]): *[ITeller](../interfaces/_types_.iteller.md)*

*Defined in [core/teller.ts:23](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/teller.ts#L23)*

**Parameters:**

Name | Type |
------ | ------ |
`zoneAddr` | string |
`tellerContractAddr` | string |
`tellerArr` | any[] |

**Returns:** *[ITeller](../interfaces/_types_.iteller.md)*

___

### `Const` updateTeller

▸ **updateTeller**(`tellerData`: [ITellerArgs](../interfaces/_types_.itellerargs.md), `wallet`: Wallet, `zoneFactoryContract`: Contract, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [core/teller.ts:255](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/teller.ts#L255)*

**Parameters:**

Name | Type |
------ | ------ |
`tellerData` | [ITellerArgs](../interfaces/_types_.itellerargs.md) |
`wallet` | Wallet |
`zoneFactoryContract` | Contract |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction›*
