[detherjs](../README.md) › [Globals](../globals.md) › ["core/wallet"](_core_wallet_.md)

# Module: "core/wallet"

**`module`** detherJS

## Index

### Functions

* [_getTokenInfo](_core_wallet_.md#const-_gettokeninfo)
* [approveToken](_core_wallet_.md#const-approvetoken)
* [execTrade](_core_wallet_.md#const-exectrade)
* [execTradeFromSell](_core_wallet_.md#const-exectradefromsell)
* [execTrade_delayed](_core_wallet_.md#const-exectrade_delayed)
* [getAllBalance](_core_wallet_.md#const-getallbalance)
* [getAvailableToken](_core_wallet_.md#const-getavailabletoken)
* [getAvailableTokenDecimals](_core_wallet_.md#const-getavailabletokendecimals)
* [getBalance](_core_wallet_.md#const-getbalance)
* [getERC20Info](_core_wallet_.md#const-geterc20info)
* [getExchangeEstimation](_core_wallet_.md#const-getexchangeestimation)
* [getUniswapLiquidity](_core_wallet_.md#const-getuniswapliquidity)
* [hasApproval](_core_wallet_.md#const-hasapproval)
* [isExchangeAvailable](_core_wallet_.md#const-isexchangeavailable)
* [sendCrypto](_core_wallet_.md#const-sendcrypto)

## Functions

### `Const` _getTokenInfo

▸ **_getTokenInfo**(`token`: any, `provider`: Provider): *Promise‹object›*

*Defined in [core/wallet.ts:142](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/wallet.ts#L142)*

**Parameters:**

Name | Type |
------ | ------ |
`token` | any |
`provider` | Provider |

**Returns:** *Promise‹object›*

___

### `Const` approveToken

▸ **approveToken**(`token`: string, `wallet`: Wallet, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [core/wallet.ts:360](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/wallet.ts#L360)*

**Parameters:**

Name | Type |
------ | ------ |
`token` | string |
`wallet` | Wallet |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction›*

___

### `Const` execTrade

▸ **execTrade**(`sellToken`: string, `buyToken`: string, `sellAmount`: string, `buyAmount`: string, `wallet`: Wallet, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [core/wallet.ts:269](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/wallet.ts#L269)*

**Parameters:**

Name | Type |
------ | ------ |
`sellToken` | string |
`buyToken` | string |
`sellAmount` | string |
`buyAmount` | string |
`wallet` | Wallet |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction›*

___

### `Const` execTradeFromSell

▸ **execTradeFromSell**(`buyToken`: string, `sellAmount`: string, `buyAmount`: string, `destAddress`: string, `wallet`: Wallet, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [core/wallet.ts:287](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/wallet.ts#L287)*

**Parameters:**

Name | Type |
------ | ------ |
`buyToken` | string |
`sellAmount` | string |
`buyAmount` | string |
`destAddress` | string |
`wallet` | Wallet |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction›*

___

### `Const` execTrade_delayed

▸ **execTrade_delayed**(`sellToken`: string, `buyToken`: string, `sellAmount`: string, `buyAmount`: string, `wallet`: Wallet, `nonce`: number, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹any›*

*Defined in [core/wallet.ts:306](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/wallet.ts#L306)*

**Parameters:**

Name | Type |
------ | ------ |
`sellToken` | string |
`buyToken` | string |
`sellAmount` | string |
`buyAmount` | string |
`wallet` | Wallet |
`nonce` | number |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹any›*

___

### `Const` getAllBalance

▸ **getAllBalance**(`address`: string, `tickers`: [ITicker](../interfaces/_types_.iticker.md)[], `provider`: Provider): *Promise‹[IBalances](../interfaces/_types_.ibalances.md)[]›*

*Defined in [core/wallet.ts:95](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/wallet.ts#L95)*

**Parameters:**

Name | Type |
------ | ------ |
`address` | string |
`tickers` | [ITicker](../interfaces/_types_.iticker.md)[] |
`provider` | Provider |

**Returns:** *Promise‹[IBalances](../interfaces/_types_.ibalances.md)[]›*

___

### `Const` getAvailableToken

▸ **getAvailableToken**(`provider`: Provider, `forLogo?`: boolean): *Promise‹[ITicker](../interfaces/_types_.iticker.md)›*

*Defined in [core/wallet.ts:129](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/wallet.ts#L129)*

**Parameters:**

Name | Type |
------ | ------ |
`provider` | Provider |
`forLogo?` | boolean |

**Returns:** *Promise‹[ITicker](../interfaces/_types_.iticker.md)›*

___

### `Const` getAvailableTokenDecimals

▸ **getAvailableTokenDecimals**(`provider`: Provider, `forLogo?`: boolean): *Promise‹any›*

*Defined in [core/wallet.ts:175](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/wallet.ts#L175)*

**Parameters:**

Name | Type |
------ | ------ |
`provider` | Provider |
`forLogo?` | boolean |

**Returns:** *Promise‹any›*

___

### `Const` getBalance

▸ **getBalance**(`address`: string, `ticker`: [ITicker](../interfaces/_types_.iticker.md), `provider`: Provider): *Promise‹[IBalances](../interfaces/_types_.ibalances.md)›*

*Defined in [core/wallet.ts:32](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/wallet.ts#L32)*

**Parameters:**

Name | Type |
------ | ------ |
`address` | string |
`ticker` | [ITicker](../interfaces/_types_.iticker.md) |
`provider` | Provider |

**Returns:** *Promise‹[IBalances](../interfaces/_types_.ibalances.md)›*

___

### `Const` getERC20Info

▸ **getERC20Info**(`address`: string, `provider`: Provider): *Promise‹[ITicker](../interfaces/_types_.iticker.md)›*

*Defined in [core/wallet.ts:76](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/wallet.ts#L76)*

**Parameters:**

Name | Type |
------ | ------ |
`address` | string |
`provider` | Provider |

**Returns:** *Promise‹[ITicker](../interfaces/_types_.iticker.md)›*

___

### `Const` getExchangeEstimation

▸ **getExchangeEstimation**(`sellToken`: string, `buyToken`: string, `sellAmount`: string, `provider`: Provider): *Promise‹string›*

*Defined in [core/wallet.ts:112](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/wallet.ts#L112)*

**Parameters:**

Name | Type |
------ | ------ |
`sellToken` | string |
`buyToken` | string |
`sellAmount` | string |
`provider` | Provider |

**Returns:** *Promise‹string›*

___

### `Const` getUniswapLiquidity

▸ **getUniswapLiquidity**(`tokenAddress`: string, `provider`: Provider): *Promise‹any›*

*Defined in [core/wallet.ts:229](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/wallet.ts#L229)*

**Parameters:**

Name | Type |
------ | ------ |
`tokenAddress` | string |
`provider` | Provider |

**Returns:** *Promise‹any›*

___

### `Const` hasApproval

▸ **hasApproval**(`owner`: string, `sellToken`: [Token](../enums/_types_.token.md), `amount`: string, `provider`: Provider): *Promise‹boolean›*

*Defined in [core/wallet.ts:198](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/wallet.ts#L198)*

**Parameters:**

Name | Type |
------ | ------ |
`owner` | string |
`sellToken` | [Token](../enums/_types_.token.md) |
`amount` | string |
`provider` | Provider |

**Returns:** *Promise‹boolean›*

___

### `Const` isExchangeAvailable

▸ **isExchangeAvailable**(`token`: string, `provider`: Provider): *Promise‹boolean›*

*Defined in [core/wallet.ts:217](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/wallet.ts#L217)*

**Parameters:**

Name | Type |
------ | ------ |
`token` | string |
`provider` | Provider |

**Returns:** *Promise‹boolean›*

___

### `Const` sendCrypto

▸ **sendCrypto**(`amount`: string, `toAddress`: string, `token`: [Token](../enums/_types_.token.md), `wallet`: Wallet, `tokenAddress`: string, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [core/wallet.ts:327](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/wallet.ts#L327)*

**Parameters:**

Name | Type |
------ | ------ |
`amount` | string |
`toAddress` | string |
`token` | [Token](../enums/_types_.token.md) |
`wallet` | Wallet |
`tokenAddress` | string |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction›*
