[detherjs](../README.md) › [Globals](../globals.md) › ["core/zone"](_core_zone_.md)

# Module: "core/zone"

## Index

### Functions

* [bid](_core_zone_.md#const-bid)
* [calcHarbergerTax](_core_zone_.md#const-calcharbergertax)
* [checkForeclosure](_core_zone_.md#const-checkforeclosure)
* [checkIfWithdrawable](_core_zone_.md#const-checkifwithdrawable)
* [claimFree](_core_zone_.md#const-claimfree)
* [create](_core_zone_.md#const-create)
* [createZoneBytes](_core_zone_.md#const-createzonebytes)
* [getOpenBid](_core_zone_.md#const-getopenbid)
* [getZoneByAddress](_core_zone_.md#const-getzonebyaddress)
* [getZoneByGeohash](_core_zone_.md#const-getzonebygeohash)
* [getZonesStatus](_core_zone_.md#const-getzonesstatus)
* [isBidderOnthisAuction](_core_zone_.md#const-isbidderonthisauction)
* [isZoneOpened](_core_zone_.md#const-iszoneopened)
* [isZoneOwned](_core_zone_.md#const-iszoneowned)
* [isZoneOwner](_core_zone_.md#const-iszoneowner)
* [processState](_core_zone_.md#const-processstate)
* [release](_core_zone_.md#const-release)
* [toLiveZone](_core_zone_.md#const-tolivezone)
* [toLiveZoneNoBidYet](_core_zone_.md#const-tolivezonenobidyet)
* [toLiveZoneRaw](_core_zone_.md#const-tolivezoneraw)
* [topUp](_core_zone_.md#const-topup)
* [withdrawAuctionsRaw](_core_zone_.md#const-withdrawauctionsraw)
* [withdrawDth](_core_zone_.md#const-withdrawdth)
* [withdrawDthAddress](_core_zone_.md#const-withdrawdthaddress)
* [withdrawFromAuction](_core_zone_.md#const-withdrawfromauction)
* [withdrawFromAuctionAddress](_core_zone_.md#const-withdrawfromauctionaddress)
* [withdrawFromAuctions](_core_zone_.md#const-withdrawfromauctions)
* [withdrawFromAuctionsAddress](_core_zone_.md#const-withdrawfromauctionsaddress)
* [zoneAuctionArrToObj](_core_zone_.md#const-zoneauctionarrtoobj)
* [zoneOwnerArrToObj](_core_zone_.md#const-zoneownerarrtoobj)

## Functions

### `Const` bid

▸ **bid**(`geohash6`: string, `bidAmount`: number, `zoneFactoryContract`: Contract, `detherTokenContract`: Contract, `wallet`: Wallet, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [core/zone.ts:583](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/zone.ts#L583)*

**Parameters:**

Name | Type |
------ | ------ |
`geohash6` | string |
`bidAmount` | number |
`zoneFactoryContract` | Contract |
`detherTokenContract` | Contract |
`wallet` | Wallet |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction›*

___

### `Const` calcHarbergerTax

▸ **calcHarbergerTax**(`startTime`: number, `endTime`: number, `dthAmount`: BigNumber): *BigNumber*

*Defined in [core/zone.ts:69](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/zone.ts#L69)*

**Parameters:**

Name | Type |
------ | ------ |
`startTime` | number |
`endTime` | number |
`dthAmount` | BigNumber |

**Returns:** *BigNumber*

___

### `Const` checkForeclosure

▸ **checkForeclosure**(`beginTime`: number, `endTime`: number, `balance`: string, `zoneContract`: Contract): *Promise‹boolean›*

*Defined in [core/zone.ts:55](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/zone.ts#L55)*

**Parameters:**

Name | Type |
------ | ------ |
`beginTime` | number |
`endTime` | number |
`balance` | string |
`zoneContract` | Contract |

**Returns:** *Promise‹boolean›*

___

### `Const` checkIfWithdrawable

▸ **checkIfWithdrawable**(`zoneContract`: Contract, `ethAddress`: string, `auctionID`: number): *Promise‹number›*

*Defined in [core/zone.ts:678](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/zone.ts#L678)*

**Parameters:**

Name | Type |
------ | ------ |
`zoneContract` | Contract |
`ethAddress` | string |
`auctionID` | number |

**Returns:** *Promise‹number›*

___

### `Const` claimFree

▸ **claimFree**(`geohash6`: string, `wallet`: Wallet, `zoneFactoryContract`: Contract, `detherTokenContract`: Contract, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [core/zone.ts:560](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/zone.ts#L560)*

**Parameters:**

Name | Type |
------ | ------ |
`geohash6` | string |
`wallet` | Wallet |
`zoneFactoryContract` | Contract |
`detherTokenContract` | Contract |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction›*

___

### `Const` create

▸ **create**(`country`: string, `geohash6`: string, `amount`: number, `zoneFactoryContract`: Contract, `detherTokenContract`: Contract, `wallet`: Wallet, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [core/zone.ts:515](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/zone.ts#L515)*

**Parameters:**

Name | Type |
------ | ------ |
`country` | string |
`geohash6` | string |
`amount` | number |
`zoneFactoryContract` | Contract |
`detherTokenContract` | Contract |
`wallet` | Wallet |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction›*

___

### `Const` createZoneBytes

▸ **createZoneBytes**(`country`: string, `geohash6`: string): *string*

*Defined in [core/zone.ts:49](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/zone.ts#L49)*

**Parameters:**

Name | Type |
------ | ------ |
`country` | string |
`geohash6` | string |

**Returns:** *string*

___

### `Const` getOpenBid

▸ **getOpenBid**(`address`: string, `zoneFactoryContract`: Contract): *Promise‹any›*

*Defined in [core/zone.ts:480](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/zone.ts#L480)*

**Parameters:**

Name | Type |
------ | ------ |
`address` | string |
`zoneFactoryContract` | Contract |

**Returns:** *Promise‹any›*

___

### `Const` getZoneByAddress

▸ **getZoneByAddress**(`address`: string, `provider`: Provider): *Promise‹[IZone](../interfaces/_types_.izone.md)›*

*Defined in [core/zone.ts:385](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/zone.ts#L385)*

**Parameters:**

Name | Type |
------ | ------ |
`address` | string |
`provider` | Provider |

**Returns:** *Promise‹[IZone](../interfaces/_types_.izone.md)›*

___

### `Const` getZoneByGeohash

▸ **getZoneByGeohash**(`geohash6`: string, `zoneFactoryContract`: Contract, `provider`: Provider): *Promise‹[IZone](../interfaces/_types_.izone.md)›*

*Defined in [core/zone.ts:336](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/zone.ts#L336)*

**Parameters:**

Name | Type |
------ | ------ |
`geohash6` | string |
`zoneFactoryContract` | Contract |
`provider` | Provider |

**Returns:** *Promise‹[IZone](../interfaces/_types_.izone.md)›*

___

### `Const` getZonesStatus

▸ **getZonesStatus**(`geohash6List`: string[], `zoneFactoryContract`: Contract, `provider`: Provider): *Promise‹any[]›*

*Defined in [core/zone.ts:424](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/zone.ts#L424)*

**Parameters:**

Name | Type |
------ | ------ |
`geohash6List` | string[] |
`zoneFactoryContract` | Contract |
`provider` | Provider |

**Returns:** *Promise‹any[]›*

___

### `Const` isBidderOnthisAuction

▸ **isBidderOnthisAuction**(`zoneAddress`: string, `ethAddress`: string, `auctionID`: number, `provider`: Provider): *Promise‹number›*

*Defined in [core/zone.ts:495](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/zone.ts#L495)*

**Parameters:**

Name | Type |
------ | ------ |
`zoneAddress` | string |
`ethAddress` | string |
`auctionID` | number |
`provider` | Provider |

**Returns:** *Promise‹number›*

___

### `Const` isZoneOpened

▸ **isZoneOpened**(`geohash6`: string, `country`: string, `geoRegistryContract`: Contract): *Promise‹Boolean›*

*Defined in [core/zone.ts:436](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/zone.ts#L436)*

**Parameters:**

Name | Type |
------ | ------ |
`geohash6` | string |
`country` | string |
`geoRegistryContract` | Contract |

**Returns:** *Promise‹Boolean›*

___

### `Const` isZoneOwned

▸ **isZoneOwned**(`geohash6`: string, `zoneFactoryContract`: Contract, `provider`: Provider): *Promise‹Boolean›*

*Defined in [core/zone.ts:304](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/zone.ts#L304)*

**Parameters:**

Name | Type |
------ | ------ |
`geohash6` | string |
`zoneFactoryContract` | Contract |
`provider` | Provider |

**Returns:** *Promise‹Boolean›*

___

### `Const` isZoneOwner

▸ **isZoneOwner**(`address`: string, `zoneFactoryContract`: Contract, `provider`: Provider): *Promise‹any›*

*Defined in [core/zone.ts:460](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/zone.ts#L460)*

**Parameters:**

Name | Type |
------ | ------ |
`address` | string |
`zoneFactoryContract` | Contract |
`provider` | Provider |

**Returns:** *Promise‹any›*

___

### `Const` processState

▸ **processState**(`zoneAddress`: string, `wallet`: Wallet, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [core/zone.ts:817](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/zone.ts#L817)*

**Parameters:**

Name | Type |
------ | ------ |
`zoneAddress` | string |
`wallet` | Wallet |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction›*

___

### `Const` release

▸ **release**(`geohash6`: string, `zoneFactoryContract`: Contract, `wallet`: Wallet, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [core/zone.ts:623](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/zone.ts#L623)*

**Parameters:**

Name | Type |
------ | ------ |
`geohash6` | string |
`zoneFactoryContract` | Contract |
`wallet` | Wallet |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction›*

___

### `Const` toLiveZone

▸ **toLiveZone**(`zoneAddress`: string, `geohash6`: string, `zoneContract`: Contract, `zoneOwner`: [IZoneOwner](../interfaces/_types_.izoneowner.md), `lastAuction`: [IZoneAuction](../interfaces/_types_.izoneauction.md)): *Promise‹any›*

*Defined in [core/zone.ts:89](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/zone.ts#L89)*

**Parameters:**

Name | Type |
------ | ------ |
`zoneAddress` | string |
`geohash6` | string |
`zoneContract` | Contract |
`zoneOwner` | [IZoneOwner](../interfaces/_types_.izoneowner.md) |
`lastAuction` | [IZoneAuction](../interfaces/_types_.izoneauction.md) |

**Returns:** *Promise‹any›*

___

### `Const` toLiveZoneNoBidYet

▸ **toLiveZoneNoBidYet**(`zoneAddress`: string, `geohash6`: string, `zoneContract`: Contract, `zoneOwner`: [IZoneOwner](../interfaces/_types_.izoneowner.md)): *Promise‹any›*

*Defined in [core/zone.ts:267](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/zone.ts#L267)*

**Parameters:**

Name | Type |
------ | ------ |
`zoneAddress` | string |
`geohash6` | string |
`zoneContract` | Contract |
`zoneOwner` | [IZoneOwner](../interfaces/_types_.izoneowner.md) |

**Returns:** *Promise‹any›*

___

### `Const` toLiveZoneRaw

▸ **toLiveZoneRaw**(`zoneAddress`: string, `geohash6`: string, `zoneContract`: Contract, `zoneOwner`: [IZoneOwner](../interfaces/_types_.izoneowner.md), `lastAuction`: [IZoneAuction](../interfaces/_types_.izoneauction.md)): *Promise‹any›*

*Defined in [core/zone.ts:181](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/zone.ts#L181)*

**Parameters:**

Name | Type |
------ | ------ |
`zoneAddress` | string |
`geohash6` | string |
`zoneContract` | Contract |
`zoneOwner` | [IZoneOwner](../interfaces/_types_.izoneowner.md) |
`lastAuction` | [IZoneAuction](../interfaces/_types_.izoneauction.md) |

**Returns:** *Promise‹any›*

___

### `Const` topUp

▸ **topUp**(`geohash6`: string, `topUpAmount`: string, `zoneFactoryContract`: Contract, `detherTokenContract`: Contract, `wallet`: Wallet, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [core/zone.ts:605](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/zone.ts#L605)*

**Parameters:**

Name | Type |
------ | ------ |
`geohash6` | string |
`topUpAmount` | string |
`zoneFactoryContract` | Contract |
`detherTokenContract` | Contract |
`wallet` | Wallet |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction›*

___

### `Const` withdrawAuctionsRaw

▸ **withdrawAuctionsRaw**(`zoneAddress`: string, `wallet`: Wallet, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [core/zone.ts:701](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/zone.ts#L701)*

**Parameters:**

Name | Type |
------ | ------ |
`zoneAddress` | string |
`wallet` | Wallet |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction›*

___

### `Const` withdrawDth

▸ **withdrawDth**(`geohash6`: string, `zoneFactoryContract`: Contract, `wallet`: Wallet, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [core/zone.ts:784](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/zone.ts#L784)*

**Parameters:**

Name | Type |
------ | ------ |
`geohash6` | string |
`zoneFactoryContract` | Contract |
`wallet` | Wallet |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction›*

___

### `Const` withdrawDthAddress

▸ **withdrawDthAddress**(`zoneAddress`: string, `wallet`: Wallet, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [core/zone.ts:803](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/zone.ts#L803)*

**Parameters:**

Name | Type |
------ | ------ |
`zoneAddress` | string |
`wallet` | Wallet |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction›*

___

### `Const` withdrawFromAuction

▸ **withdrawFromAuction**(`geohash6`: string, `auctionId`: number, `zoneFactoryContract`: Contract, `wallet`: Wallet, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [core/zone.ts:642](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/zone.ts#L642)*

**Parameters:**

Name | Type |
------ | ------ |
`geohash6` | string |
`auctionId` | number |
`zoneFactoryContract` | Contract |
`wallet` | Wallet |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction›*

___

### `Const` withdrawFromAuctionAddress

▸ **withdrawFromAuctionAddress**(`zoneAddress`: string, `auctionId`: number, `wallet`: Wallet, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [core/zone.ts:662](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/zone.ts#L662)*

**Parameters:**

Name | Type |
------ | ------ |
`zoneAddress` | string |
`auctionId` | number |
`wallet` | Wallet |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction›*

___

### `Const` withdrawFromAuctions

▸ **withdrawFromAuctions**(`geohash6`: string, `auctionIds`: number[], `zoneFactoryContract`: Contract, `wallet`: Wallet, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [core/zone.ts:744](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/zone.ts#L744)*

**Parameters:**

Name | Type |
------ | ------ |
`geohash6` | string |
`auctionIds` | number[] |
`zoneFactoryContract` | Contract |
`wallet` | Wallet |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction›*

___

### `Const` withdrawFromAuctionsAddress

▸ **withdrawFromAuctionsAddress**(`zoneAddress`: string, `auctionIds`: number[], `wallet`: Wallet, `txOptions`: [ITxOptions](../interfaces/_types_.itxoptions.md)): *Promise‹ContractTransaction›*

*Defined in [core/zone.ts:766](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/zone.ts#L766)*

**Parameters:**

Name | Type |
------ | ------ |
`zoneAddress` | string |
`auctionIds` | number[] |
`wallet` | Wallet |
`txOptions` | [ITxOptions](../interfaces/_types_.itxoptions.md) |

**Returns:** *Promise‹ContractTransaction›*

___

### `Const` zoneAuctionArrToObj

▸ **zoneAuctionArrToObj**(`onchainZoneAuction`: any[]): *[IZoneAuction](../interfaces/_types_.izoneauction.md)*

*Defined in [core/zone.ts:35](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/zone.ts#L35)*

**Parameters:**

Name | Type |
------ | ------ |
`onchainZoneAuction` | any[] |

**Returns:** *[IZoneAuction](../interfaces/_types_.izoneauction.md)*

___

### `Const` zoneOwnerArrToObj

▸ **zoneOwnerArrToObj**(`onchainZoneOwner`: any[]): *[IZoneOwner](../interfaces/_types_.izoneowner.md)*

*Defined in [core/zone.ts:23](https://github.com/dethertech/detherJS/blob/34cf05e/src/core/zone.ts#L23)*

**Parameters:**

Name | Type |
------ | ------ |
`onchainZoneOwner` | any[] |

**Returns:** *[IZoneOwner](../interfaces/_types_.izoneowner.md)*
