[detherjs](../README.md) › [Globals](../globals.md) › ["helpers/contracts"](_helpers_contracts_.md)

# Module: "helpers/contracts"

## Index

### Functions

* [get](_helpers_contracts_.md#const-get)
* [getAbi](_helpers_contracts_.md#const-getabi)
* [getContractAddress](_helpers_contracts_.md#const-getcontractaddress)
* [getErc20](_helpers_contracts_.md#const-geterc20)
* [getErc20Address](_helpers_contracts_.md#const-geterc20address)
* [getUniswapExchangeAddress](_helpers_contracts_.md#const-getuniswapexchangeaddress)

### Object literals

* [ABI](_helpers_contracts_.md#const-abi)

## Functions

### `Const` get

▸ **get**(`provider`: Provider, `contractName`: [DetherContract](../enums/_types_.dethercontract.md) | [ExternalContract](../enums/_types_.externalcontract.md), `address?`: string, `overwriteAbi?`: any): *Promise‹any›*

*Defined in [helpers/contracts.ts:43](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/contracts.ts#L43)*

**Parameters:**

Name | Type |
------ | ------ |
`provider` | Provider |
`contractName` | [DetherContract](../enums/_types_.dethercontract.md) &#124; [ExternalContract](../enums/_types_.externalcontract.md) |
`address?` | string |
`overwriteAbi?` | any |

**Returns:** *Promise‹any›*

___

### `Const` getAbi

▸ **getAbi**(`contractName`: [DetherContract](../enums/_types_.dethercontract.md) | [ExternalContract](../enums/_types_.externalcontract.md)): *Promise‹any›*

*Defined in [helpers/contracts.ts:27](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/contracts.ts#L27)*

**Parameters:**

Name | Type |
------ | ------ |
`contractName` | [DetherContract](../enums/_types_.dethercontract.md) &#124; [ExternalContract](../enums/_types_.externalcontract.md) |

**Returns:** *Promise‹any›*

___

### `Const` getContractAddress

▸ **getContractAddress**(`contractName`: [DetherContract](../enums/_types_.dethercontract.md) | [ExternalContract](../enums/_types_.externalcontract.md), `networkName`: any): *Promise‹any›*

*Defined in [helpers/contracts.ts:31](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/contracts.ts#L31)*

**Parameters:**

Name | Type |
------ | ------ |
`contractName` | [DetherContract](../enums/_types_.dethercontract.md) &#124; [ExternalContract](../enums/_types_.externalcontract.md) |
`networkName` | any |

**Returns:** *Promise‹any›*

___

### `Const` getErc20

▸ **getErc20**(`provider`: Provider, `tokenName`: [Token](../enums/_types_.token.md)): *Promise‹any›*

*Defined in [helpers/contracts.ts:57](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/contracts.ts#L57)*

**Parameters:**

Name | Type |
------ | ------ |
`provider` | Provider |
`tokenName` | [Token](../enums/_types_.token.md) |

**Returns:** *Promise‹any›*

___

### `Const` getErc20Address

▸ **getErc20Address**(`provider`: Provider, `address`: string): *Promise‹any›*

*Defined in [helpers/contracts.ts:67](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/contracts.ts#L67)*

**Parameters:**

Name | Type |
------ | ------ |
`provider` | Provider |
`address` | string |

**Returns:** *Promise‹any›*

___

### `Const` getUniswapExchangeAddress

▸ **getUniswapExchangeAddress**(`provider`: Provider, `token`: string): *Promise‹any›*

*Defined in [helpers/contracts.ts:35](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/contracts.ts#L35)*

**Parameters:**

Name | Type |
------ | ------ |
`provider` | Provider |
`token` | string |

**Returns:** *Promise‹any›*

## Object literals

### `Const` ABI

### ▪ **ABI**: *object*

*Defined in [helpers/contracts.ts:6](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/contracts.ts#L6)*

###  [DetherContract.CertifierRegistry]

• **[DetherContract.CertifierRegistry]**: *any* = require('../../abi/dether/CertifierRegistry.json').abi

*Defined in [helpers/contracts.ts:15](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/contracts.ts#L15)*

###  [DetherContract.DetherToken]

• **[DetherContract.DetherToken]**: *any* = require('../../abi/dether/DetherToken.json').abi

*Defined in [helpers/contracts.ts:8](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/contracts.ts#L8)*

###  [DetherContract.GeoRegistry]

• **[DetherContract.GeoRegistry]**: *any* = require('../../abi/dether/GeoRegistry.json').abi

*Defined in [helpers/contracts.ts:9](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/contracts.ts#L9)*

###  [DetherContract.ShopDispute]

• **[DetherContract.ShopDispute]**: *any* = require('../../abi/dether/ShopDispute.json').abi

*Defined in [helpers/contracts.ts:16](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/contracts.ts#L16)*

###  [DetherContract.Shops]

• **[DetherContract.Shops]**: *any* = require('../../abi/dether/Shops.json').abi

*Defined in [helpers/contracts.ts:12](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/contracts.ts#L12)*

###  [DetherContract.TaxCollector]

• **[DetherContract.TaxCollector]**: *any* = require('../../abi/dether/TaxCollector.json').abi

*Defined in [helpers/contracts.ts:18](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/contracts.ts#L18)*

###  [DetherContract.Teller]

• **[DetherContract.Teller]**: *any* = require('../../abi/dether/Teller.json').abi

*Defined in [helpers/contracts.ts:14](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/contracts.ts#L14)*

###  [DetherContract.TokenRegistry]

• **[DetherContract.TokenRegistry]**: *any* = require('../../abi/dether/TokenRegistry.json').abi

*Defined in [helpers/contracts.ts:17](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/contracts.ts#L17)*

###  [DetherContract.Users]

• **[DetherContract.Users]**: *any* = require('../../abi/dether/Users.json').abi

*Defined in [helpers/contracts.ts:10](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/contracts.ts#L10)*

###  [DetherContract.ZoneFactory]

• **[DetherContract.ZoneFactory]**: *any* = require('../../abi/dether/ZoneFactory.json').abi

*Defined in [helpers/contracts.ts:11](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/contracts.ts#L11)*

###  [DetherContract.Zone]

• **[DetherContract.Zone]**: *any* = require('../../abi/dether/Zone.json').abi

*Defined in [helpers/contracts.ts:13](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/contracts.ts#L13)*

###  [ExternalContract.erc20]

• **[ExternalContract.erc20]**: *any* = require('../../abi/external/erc20.json')

*Defined in [helpers/contracts.ts:21](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/contracts.ts#L21)*

###  [ExternalContract.kyberNetworkProxy]

• **[ExternalContract.kyberNetworkProxy]**: *any* = require('../../abi/external/kyberNetworkProxy.json')

*Defined in [helpers/contracts.ts:22](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/contracts.ts#L22)*

###  [ExternalContract.uniswapExchange]

• **[ExternalContract.uniswapExchange]**: *any* = require('../../abi/external/uniswapExchange.json')

*Defined in [helpers/contracts.ts:23](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/contracts.ts#L23)*

###  [ExternalContract.uniswapFactory]

• **[ExternalContract.uniswapFactory]**: *any* = require('../../abi/external/uniswapFactory.json')

*Defined in [helpers/contracts.ts:24](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/contracts.ts#L24)*
