[detherjs](../README.md) › [Globals](../globals.md) › ["helpers/util"](_helpers_util_.md)

# Module: "helpers/util"

## Index

### Functions

* [add0x](_helpers_util_.md#const-add0x)
* [bytes32ToIpfsHash](_helpers_util_.md#const-bytes32toipfshash)
* [getMaxUint256Value](_helpers_util_.md#const-getmaxuint256value)
* [ipfsHashToBytes32](_helpers_util_.md#const-ipfshashtobytes32)
* [remove0x](_helpers_util_.md#const-remove0x)
* [stringToBytes](_helpers_util_.md#const-stringtobytes)
* [timestampNow](_helpers_util_.md#const-timestampnow)
* [toNBytes](_helpers_util_.md#const-tonbytes)
* [toUtf8](_helpers_util_.md#const-toutf8)

## Functions

### `Const` add0x

▸ **add0x**(`txHash`: string): *string*

*Defined in [helpers/util.ts:28](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/util.ts#L28)*

**Parameters:**

Name | Type |
------ | ------ |
`txHash` | string |

**Returns:** *string*

___

### `Const` bytes32ToIpfsHash

▸ **bytes32ToIpfsHash**(`bytes32Hex`: string): *string*

*Defined in [helpers/util.ts:46](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/util.ts#L46)*

**Parameters:**

Name | Type |
------ | ------ |
`bytes32Hex` | string |

**Returns:** *string*

___

### `Const` getMaxUint256Value

▸ **getMaxUint256Value**(): *BigNumber*

*Defined in [helpers/util.ts:60](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/util.ts#L60)*

return the max uint256 value, which is 2^256 - 1

**Returns:** *BigNumber*

max uint256 value as a BigNumber

___

### `Const` ipfsHashToBytes32

▸ **ipfsHashToBytes32**(`ipfsListing`: string): *string*

*Defined in [helpers/util.ts:51](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/util.ts#L51)*

**Parameters:**

Name | Type |
------ | ------ |
`ipfsListing` | string |

**Returns:** *string*

___

### `Const` remove0x

▸ **remove0x**(`val`: string): *string*

*Defined in [helpers/util.ts:32](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/util.ts#L32)*

**Parameters:**

Name | Type |
------ | ------ |
`val` | string |

**Returns:** *string*

___

### `Const` stringToBytes

▸ **stringToBytes**(`str`: string, `len`: number): *string*

*Defined in [helpers/util.ts:5](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/util.ts#L5)*

**Parameters:**

Name | Type |
------ | ------ |
`str` | string |
`len` | number |

**Returns:** *string*

___

### `Const` timestampNow

▸ **timestampNow**(): *number*

*Defined in [helpers/util.ts:24](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/util.ts#L24)*

**Returns:** *number*

___

### `Const` toNBytes

▸ **toNBytes**(`str`: string, `n`: number): *string*

*Defined in [helpers/util.ts:36](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/util.ts#L36)*

**Parameters:**

Name | Type |
------ | ------ |
`str` | string |
`n` | number |

**Returns:** *string*

___

### `Const` toUtf8

▸ **toUtf8**(`hex`: string): *string*

*Defined in [helpers/util.ts:9](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/util.ts#L9)*

**Parameters:**

Name | Type |
------ | ------ |
`hex` | string |

**Returns:** *string*
