[detherjs](../README.md) › [Globals](../globals.md) › ["helpers/validate"](_helpers_validate_.md)

# Module: "helpers/validate"

## Index

### Variables

* [COUNTRY_CODES](_helpers_validate_.md#const-country_codes)
* [GEOHAS_CHARS](_helpers_validate_.md#const-geohas_chars)

### Functions

* [countryCode](_helpers_validate_.md#const-countrycode)
* [currencyId](_helpers_validate_.md#const-currencyid)
* [ethAddress](_helpers_validate_.md#const-ethaddress)
* [geohash](_helpers_validate_.md#const-geohash)
* [ipfsHash](_helpers_validate_.md#const-ipfshash)
* [minStake](_helpers_validate_.md#const-minstake)
* [refFees](_helpers_validate_.md#const-reffees)
* [sellAmount](_helpers_validate_.md#const-sellamount)
* [sellAmountUnit](_helpers_validate_.md#const-sellamountunit)
* [shopDisputeID](_helpers_validate_.md#const-shopdisputeid)
* [telegramUsername](_helpers_validate_.md#const-telegramusername)
* [tellerBuyerInfo](_helpers_validate_.md#const-tellerbuyerinfo)
* [tellerDescrInfo](_helpers_validate_.md#const-tellerdescrinfo)
* [tellerSellerInfo](_helpers_validate_.md#const-tellersellerinfo)
* [tier](_helpers_validate_.md#const-tier)
* [token](_helpers_validate_.md#const-token)
* [txHash](_helpers_validate_.md#const-txhash)
* [url](_helpers_validate_.md#const-url)
* [zonePrice](_helpers_validate_.md#const-zoneprice)

## Variables

### `Const` COUNTRY_CODES

• **COUNTRY_CODES**: *string[]* = [
  "AD",
  "AU",
  "BI",
  "BZ",
  "CO",
  "DO",
  "FK",
  "GL",
  "HM",
  "IQ",
  "KI",
  "LI",
  "ME",
  "MS",
  "NF",
  "PE",
  "PW",
  "SE",
  "ST",
  "TL",
  "UM",
  "WF",
  "AE",
  "WS",
  "AF",
  "YE",
  "AG",
  "ZA",
  "AI",
  "ZM",
  "AL",
  "ZW",
  "AM",
  "AR",
  "AO",
  "AS",
  "AT",
  "AW",
  "BJ",
  "CA",
  "CR",
  "DZ",
  "FM",
  "GM",
  "HN",
  "IR",
  "KM",
  "LK",
  "MF",
  "MT",
  "NG",
  "PF",
  "PY",
  "SG",
  "SV",
  "TM",
  "US",
  "AX",
  "BL",
  "CD",
  "CU",
  "EC",
  "FO",
  "GN",
  "HR",
  "IS",
  "KN",
  "LR",
  "MG",
  "MU",
  "NI",
  "PG",
  "QA",
  "SH",
  "SX",
  "TN",
  "UY",
  "AZ",
  "BM",
  "CF",
  "CV",
  "EE",
  "FR",
  "GQ",
  "HT",
  "IT",
  "KP",
  "LS",
  "MH",
  "MV",
  "NL",
  "PH",
  "RO",
  "SI",
  "SY",
  "TO",
  "UZ",
  "BA",
  "BN",
  "CG",
  "CW",
  "EG",
  "GA",
  "GR",
  "HU",
  "JE",
  "KR",
  "LT",
  "MK",
  "MW",
  "NO",
  "PK",
  "RS",
  "SK",
  "SZ",
  "TR",
  "VA",
  "BB",
  "BO",
  "CH",
  "CY",
  "EH",
  "GB",
  "GS",
  "ID",
  "JM",
  "KW",
  "LU",
  "ML",
  "MX",
  "NP",
  "PL",
  "RU",
  "SL",
  "TC",
  "TT",
  "VC",
  "BD",
  "BR",
  "CI",
  "CZ",
  "ER",
  "GD",
  "GT",
  "IE",
  "JO",
  "KY",
  "LV",
  "MM",
  "MY",
  "NR",
  "PM",
  "RW",
  "SM",
  "TD",
  "TV",
  "VE",
  "BE",
  "BS",
  "CK",
  "DE",
  "ES",
  "GE",
  "GU",
  "IL",
  "JP",
  "KZ",
  "LY",
  "MN",
  "MZ",
  "NU",
  "PN",
  "SA",
  "SN",
  "TF",
  "TW",
  "VG",
  "BF",
  "BT",
  "CL",
  "DJ",
  "ET",
  "GG",
  "GW",
  "IM",
  "KE",
  "LA",
  "MA",
  "MO",
  "NA",
  "NZ",
  "PR",
  "SB",
  "SO",
  "TG",
  "TZ",
  "VI",
  "BG",
  "BW",
  "CM",
  "DK",
  "FI",
  "GH",
  "GY",
  "IN",
  "KG",
  "LB",
  "MC",
  "MP",
  "NC",
  "OM",
  "PS",
  "SC",
  "SR",
  "TH",
  "UA",
  "VN",
  "BH",
  "BY",
  "CN",
  "DM",
  "FJ",
  "GI",
  "HK",
  "IO",
  "KH",
  "LC",
  "MD",
  "MR",
  "NE",
  "PA",
  "PT",
  "SD",
  "SS",
  "TJ",
  "UG",
  "VU",
]

*Defined in [helpers/validate.ts:6](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/validate.ts#L6)*

___

### `Const` GEOHAS_CHARS

• **GEOHAS_CHARS**: *string[]* = [
  "v",
  "y",
  "z",
  "b",
  "c",
  "f",
  "g",
  "u",
  "t",
  "w",
  "x",
  "8",
  "9",
  "d",
  "e",
  "s",
  "m",
  "q",
  "r",
  "2",
  "3",
  "6",
  "7",
  "k",
  "j",
  "n",
  "p",
  "0",
  "1",
  "4",
  "5",
  "h",
]

*Defined in [helpers/validate.ts:246](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/validate.ts#L246)*

## Functions

### `Const` countryCode

▸ **countryCode**(`country`: string): *void*

*Defined in [helpers/validate.ts:331](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/validate.ts#L331)*

**Parameters:**

Name | Type |
------ | ------ |
`country` | string |

**Returns:** *void*

___

### `Const` currencyId

▸ **currencyId**(`currencyId`: number): *void*

*Defined in [helpers/validate.ts:380](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/validate.ts#L380)*

**Parameters:**

Name | Type |
------ | ------ |
`currencyId` | number |

**Returns:** *void*

___

### `Const` ethAddress

▸ **ethAddress**(`address`: string): *void*

*Defined in [helpers/validate.ts:291](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/validate.ts#L291)*

**Parameters:**

Name | Type |
------ | ------ |
`address` | string |

**Returns:** *void*

___

### `Const` geohash

▸ **geohash**(`str`: string, `len`: number): *void*

*Defined in [helpers/validate.ts:281](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/validate.ts#L281)*

**Parameters:**

Name | Type |
------ | ------ |
`str` | string |
`len` | number |

**Returns:** *void*

___

### `Const` ipfsHash

▸ **ipfsHash**(`_`: any): *boolean*

*Defined in [helpers/validate.ts:431](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/validate.ts#L431)*

**Parameters:**

Name | Type |
------ | ------ |
`_` | any |

**Returns:** *boolean*

___

### `Const` minStake

▸ **minStake**(`amount`: number): *void*

*Defined in [helpers/validate.ts:367](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/validate.ts#L367)*

**Parameters:**

Name | Type |
------ | ------ |
`amount` | number |

**Returns:** *void*

___

### `Const` refFees

▸ **refFees**(`reffees`: number): *void*

*Defined in [helpers/validate.ts:374](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/validate.ts#L374)*

**Parameters:**

Name | Type |
------ | ------ |
`reffees` | number |

**Returns:** *void*

___

### `Const` sellAmount

▸ **sellAmount**(`sellAmount`: number): *void*

*Defined in [helpers/validate.ts:361](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/validate.ts#L361)*

**Parameters:**

Name | Type |
------ | ------ |
`sellAmount` | number |

**Returns:** *void*

___

### `Const` sellAmountUnit

▸ **sellAmountUnit**(`unit`: [Unit](../enums/_types_.unit.md)): *void*

*Defined in [helpers/validate.ts:341](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/validate.ts#L341)*

**Parameters:**

Name | Type |
------ | ------ |
`unit` | [Unit](../enums/_types_.unit.md) |

**Returns:** *void*

___

### `Const` shopDisputeID

▸ **shopDisputeID**(`disputeID`: number): *void*

*Defined in [helpers/validate.ts:414](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/validate.ts#L414)*

**Parameters:**

Name | Type |
------ | ------ |
`disputeID` | number |

**Returns:** *void*

___

### `Const` telegramUsername

▸ **telegramUsername**(`messenger`: string | undefined): *void*

*Defined in [helpers/validate.ts:405](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/validate.ts#L405)*

**Parameters:**

Name | Type |
------ | ------ |
`messenger` | string &#124; undefined |

**Returns:** *void*

___

### `Const` tellerBuyerInfo

▸ **tellerBuyerInfo**(`isBuyer`: boolean, `buyRate`: number): *void*

*Defined in [helpers/validate.ts:392](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/validate.ts#L392)*

**Parameters:**

Name | Type |
------ | ------ |
`isBuyer` | boolean |
`buyRate` | number |

**Returns:** *void*

___

### `Const` tellerDescrInfo

▸ **tellerDescrInfo**(`descr`: string): *void*

*Defined in [helpers/validate.ts:386](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/validate.ts#L386)*

**Parameters:**

Name | Type |
------ | ------ |
`descr` | string |

**Returns:** *void*

___

### `Const` tellerSellerInfo

▸ **tellerSellerInfo**(`isSeller`: boolean, `sellRate`: number): *void*

*Defined in [helpers/validate.ts:397](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/validate.ts#L397)*

**Parameters:**

Name | Type |
------ | ------ |
`isSeller` | boolean |
`sellRate` | number |

**Returns:** *void*

___

### `Const` tier

▸ **tier**(`tier`: number): *void*

*Defined in [helpers/validate.ts:420](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/validate.ts#L420)*

**Parameters:**

Name | Type |
------ | ------ |
`tier` | number |

**Returns:** *void*

___

### `Const` token

▸ **token**(`token`: [Token](../enums/_types_.token.md)): *void*

*Defined in [helpers/validate.ts:349](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/validate.ts#L349)*

**Parameters:**

Name | Type |
------ | ------ |
`token` | [Token](../enums/_types_.token.md) |

**Returns:** *void*

___

### `Const` txHash

▸ **txHash**(`txHash`: string): *void*

*Defined in [helpers/validate.ts:355](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/validate.ts#L355)*

**Parameters:**

Name | Type |
------ | ------ |
`txHash` | string |

**Returns:** *void*

___

### `Const` url

▸ **url**(`url`: string): *void*

*Defined in [helpers/validate.ts:426](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/validate.ts#L426)*

**Parameters:**

Name | Type |
------ | ------ |
`url` | string |

**Returns:** *void*

___

### `Const` zonePrice

▸ **zonePrice**(`zonePrice`: string): *void*

*Defined in [helpers/validate.ts:336](https://github.com/dethertech/detherJS/blob/34cf05e/src/helpers/validate.ts#L336)*

**Parameters:**

Name | Type |
------ | ------ |
`zonePrice` | string |

**Returns:** *void*
