"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class ExchangeBase {
    constructor(sellToken, buyToken) {
        this.sellToken = sellToken;
        this.buyToken = buyToken;
    }
    async estimate(sellAmount, provider) {
        throw new Error("estimate method not implented");
    }
    async trade(sellAmount, buyAmount, wallet, txOptions) {
        throw new Error("trade method not implented");
    }
    async tradeFromSell(sellAmount, buyAmount, destAddress, wallet, txOptions) {
        throw new Error("trade method not implented");
    }
    async trade_delayed(sellAmount, buyAmount, wallet, nonce, txOptions) {
        throw new Error("trade_delayed method not implented");
    }
}
exports.default = ExchangeBase;
//# sourceMappingURL=base.js.map