"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getTransactionStatus = void 0;
const util = __importStar(require("../helpers/util"));
const validate = __importStar(require("../helpers/validate"));
const types_1 = require("../types");
// -------------------- //
//        Getters       //
// -------------------- //
exports.getTransactionStatus = async (txHash, provider) => {
    validate.txHash(txHash);
    try {
        const tx = await provider.getTransaction(util.add0x(txHash));
        if (tx && tx.blockHash) {
            const receipt = await provider.getTransactionReceipt(util.add0x(txHash));
            return receipt.status === 1 ? types_1.TransactionStatus.success : types_1.TransactionStatus.error;
        }
        return tx ? types_1.TransactionStatus.pending : types_1.TransactionStatus.unknown;
    }
    catch (e) {
        return types_1.TransactionStatus.unknown;
    }
};
//# sourceMappingURL=util.js.map