"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.processState = exports.withdrawDthAddress = exports.withdrawDth = exports.withdrawFromAuctionsAddress = exports.withdrawFromAuctions = exports.withdrawAuctionsRaw = exports.withdrawFromAuctionAddress = exports.withdrawFromAuction = exports.release = exports.topUp = exports.bid = exports.claimFree = exports.create = exports.isBidderOnthisAuction = exports.getOpenBid = exports.isZoneOwner = exports.isZoneOpened = exports.getZonesStatus = exports.getZoneByAddress = exports.getZoneByGeohash = exports.isZoneOwned = exports.getGlobalParams = exports.getCountryFloorPrice = exports.toLiveZoneNoBidYet = exports.toLiveZoneRaw = exports.toLiveZone = exports.zoneAuctionArrToObj = exports.zoneOwnerArrToObj = void 0;
const ethers_1 = require("ethers");
const constants = __importStar(require("../constants"));
const util = __importStar(require("../helpers/util"));
const convert = __importStar(require("../helpers/convert"));
const validate = __importStar(require("../helpers/validate"));
const contract = __importStar(require("../helpers/contracts"));
const types_1 = require("../types");
// -------------------- //
//      Formatters      //
// -------------------- //
exports.zoneOwnerArrToObj = (onchainZoneOwner) => ({
    address: onchainZoneOwner[0],
    startTime: onchainZoneOwner[1].toNumber(),
    staked: convert.weiToEthNumber(onchainZoneOwner[2].toString()),
    balance: convert.weiToEthNumber(onchainZoneOwner[3].toString()),
    lastTaxTime: onchainZoneOwner[4].toNumber(),
    auctionId: onchainZoneOwner[5].toNumber() > 0 ? onchainZoneOwner[5] : undefined,
});
// const hasEnded = util.timestampNow() >= onchainZoneAuction[3].toNumber();
exports.zoneAuctionArrToObj = (onchainZoneAuction) => ({
    id: onchainZoneAuction[0].toNumber(),
    state: onchainZoneAuction[1].toNumber(),
    startTime: onchainZoneAuction[2].toNumber(),
    endTime: onchainZoneAuction[3].toNumber(),
    highestBidder: onchainZoneAuction[4] !== constants.ADDRESS_ZERO
        ? onchainZoneAuction[4]
        : undefined,
    highestBid: convert.weiToEthNumber(onchainZoneAuction[5].toString())
});
const createZoneBytes = (country, geohash6) => {
    // if (tier.toString().length === 1)
    const data = [util.toNBytes(country, 2), util.toNBytes(geohash6, 6)].join("");
    return `0x${data}`;
};
const checkForeclosure = async (beginTime, endTime, balance, zoneContract) => {
    if (beginTime >= endTime)
        return false;
    const [, taxesDue] = await zoneContract.calcHarbergerTax(beginTime, endTime, convert.ethToWei(Number(balance)));
    return taxesDue.gte(convert.ethToWei(Number(balance)));
};
const calcHarbergerTax = (startTime, endTime, dthAmount) => {
    const taxAmountBN = dthAmount
        .mul(endTime - startTime)
        .mul(4)
        .div(10000)
        .div(86400);
    /*
    console.log(
      "tax amount",
      taxAmountBN.toString(),
      "keep amount",
      dthAmount.sub(taxAmountBN).toString()
    );*/
    return taxAmountBN;
};
// here zone is updated on the state it should be even before process state is called in the smart contract
exports.toLiveZone = async (zoneAddress, geohash6, zoneContract, zoneOwner, lastAuction) => {
    console.log("toLiveZone");
    let zoneStatus;
    if (zoneOwner.startTime === 0)
        zoneStatus = types_1.ZoneStatus.Claimable;
    else {
        const now = util.timestampNow();
        // TODO: calc harberger tax locally
        if (lastAuction.id === 0 || lastAuction.state === types_1.ZoneAuctionState.ended) {
            // there is NO active auction, check zoneowner tax payments
            if (zoneOwner.lastTaxTime >= now)
                zoneStatus = types_1.ZoneStatus.Occupied;
            else {
                const myTaxesDue = calcHarbergerTax(zoneOwner.lastTaxTime, now, convert.ethToWeiBN(zoneOwner.balance));
                if (myTaxesDue.gte(convert.ethToWei(zoneOwner.balance)))
                    zoneStatus = types_1.ZoneStatus.Claimable;
                else
                    zoneStatus = types_1.ZoneStatus.Occupied;
            }
        }
        else {
            // there is an active auction
            // check if auction is still open
            if (now < lastAuction.endTime)
                zoneStatus = types_1.ZoneStatus.Occupied;
            else {
                // this auction has actually ended
                lastAuction.state = types_1.ZoneAuctionState.ended;
                if (zoneOwner.address === lastAuction.highestBidder) {
                    // winner is current zone owner
                    zoneOwner.auctionId = lastAuction.id;
                    // strange here as its already done in smart contract
                    zoneOwner.staked = Number(zoneOwner.staked);
                    //             Number(zoneOwner.staked) + Number(lastAuction.highestBid);
                    zoneOwner.balance = Number(zoneOwner.balance);
                    // Number(zoneOwner.balance) + Number(lastAuction.highestBid);
                    if (zoneOwner.lastTaxTime >= now)
                        zoneStatus = types_1.ZoneStatus.Occupied;
                    else {
                        const myTaxesDue = calcHarbergerTax(zoneOwner.lastTaxTime, now, convert.ethToWeiBN(zoneOwner.balance));
                        // zone owner needs to pay harberger taxes, but dows not have enough balance
                        if (myTaxesDue.gte(convert.ethToWei(zoneOwner.balance)))
                            zoneStatus = types_1.ZoneStatus.Claimable;
                        else
                            zoneStatus = types_1.ZoneStatus.Occupied;
                    }
                    // zone owner can pay for his taxes
                }
                else {
                    // winner is NOT the current zone owner
                    zoneOwner.address = lastAuction.highestBidder;
                    zoneOwner.startTime = lastAuction.endTime;
                    zoneOwner.staked = lastAuction.highestBid;
                    zoneOwner.balance = lastAuction.highestBid;
                    zoneOwner.lastTaxTime = now;
                    zoneOwner.auctionId = lastAuction.id;
                    if (zoneOwner.lastTaxTime >= now)
                        zoneStatus = types_1.ZoneStatus.Occupied;
                    else {
                        const myTaxesDue = calcHarbergerTax(zoneOwner.lastTaxTime, now, convert.ethToWeiBN(zoneOwner.balance));
                        // zone owner needs to pay harberger taxes, but dows not have enough balance
                        if (myTaxesDue.gte(convert.ethToWei(zoneOwner.balance)))
                            zoneStatus = types_1.ZoneStatus.Claimable;
                        else
                            zoneStatus = types_1.ZoneStatus.Occupied;
                    }
                }
            }
        }
    }
    return {
        geohash: geohash6,
        status: zoneStatus,
        address: zoneAddress,
        owner: zoneOwner.address !== constants.ADDRESS_ZERO ? zoneOwner : undefined,
        auction: lastAuction.id !== 0 ? lastAuction : undefined,
    };
};
// here the state is the always the same that the current state on the smart contract
exports.toLiveZoneRaw = async (zoneAddress, geohash6, zoneContract, zoneOwner, lastAuction) => {
    let zoneStatus;
    if (zoneOwner.startTime === 0)
        zoneStatus = types_1.ZoneStatus.Claimable;
    else {
        const now = util.timestampNow();
        // TODO: calc harberger tax locally
        if (lastAuction.id === 0 || lastAuction.state === types_1.ZoneAuctionState.ended) {
            // there is NO active auction, check zoneowner tax payments
            if (zoneOwner.lastTaxTime >= now)
                zoneStatus = types_1.ZoneStatus.Occupied;
            else {
                const myTaxesDue = calcHarbergerTax(zoneOwner.lastTaxTime, now, convert.ethToWeiBN(zoneOwner.balance));
                if (myTaxesDue.gte(convert.ethToWei(zoneOwner.balance)))
                    zoneStatus = types_1.ZoneStatus.Claimable;
                else
                    zoneStatus = types_1.ZoneStatus.Occupied;
            }
        }
        else {
            // there is an active auction
            // check if auction is still open
            if (now < lastAuction.endTime)
                zoneStatus = types_1.ZoneStatus.Occupied;
            else {
                // this auction has actually ended
                lastAuction.state = types_1.ZoneAuctionState.ended;
                if (zoneOwner.address === lastAuction.highestBidder) {
                    // winner is current zone owner
                    zoneOwner.auctionId = lastAuction.id;
                    // strange here as its already done in smart contract
                    zoneOwner.staked = Number(zoneOwner.staked);
                    //             Number(zoneOwner.staked) + Number(lastAuction.highestBid);
                    zoneOwner.balance = Number(zoneOwner.balance);
                    // Number(zoneOwner.balance) + Number(lastAuction.highestBid);
                    if (zoneOwner.lastTaxTime >= now)
                        zoneStatus = types_1.ZoneStatus.Occupied;
                    else {
                        const myTaxesDue = calcHarbergerTax(zoneOwner.lastTaxTime, now, convert.ethToWeiBN(zoneOwner.balance));
                        // zone owner needs to pay harberger taxes, but dows not have enough balance
                        // if (taxesDue.gte(convert.ethToWei(zoneOwner.balance)))
                        if (myTaxesDue.gte(convert.ethToWei(zoneOwner.balance)))
                            zoneStatus = types_1.ZoneStatus.Claimable;
                        else
                            zoneStatus = types_1.ZoneStatus.Occupied;
                    }
                    // zone owner can pay for his taxes
                }
                else {
                    // winner is NOT the current zone owner
                    zoneOwner.startTime = lastAuction.endTime;
                    if (zoneOwner.lastTaxTime >= now)
                        zoneStatus = types_1.ZoneStatus.Occupied;
                    else {
                        const myTaxesDue = calcHarbergerTax(zoneOwner.lastTaxTime, now, convert.ethToWeiBN(zoneOwner.balance));
                        // zone owner needs to pay harberger taxes, but dows not have enough balance
                        if (myTaxesDue.gte(convert.ethToWei(zoneOwner.balance)))
                            zoneStatus = types_1.ZoneStatus.Claimable;
                        else
                            zoneStatus = types_1.ZoneStatus.Occupied;
                    }
                }
            }
        }
    }
    return {
        geohash: geohash6,
        status: zoneStatus,
        address: zoneAddress,
        owner: zoneOwner.address !== constants.ADDRESS_ZERO ? zoneOwner : undefined,
        auction: lastAuction.id !== 0 ? lastAuction : undefined,
    };
};
//
exports.toLiveZoneNoBidYet = async (zoneAddress, geohash6, zoneContract, zoneOwner) => {
    let zoneStatus;
    if (zoneOwner.startTime === 0)
        zoneStatus = types_1.ZoneStatus.Claimable;
    else {
        const now = util.timestampNow();
        // TODO: calc harberger tax locally
        // there is NO active auction, check zoneowner tax payments
        if (zoneOwner.lastTaxTime >= now)
            zoneStatus = types_1.ZoneStatus.Occupied;
        else {
            const myTaxesDue = calcHarbergerTax(zoneOwner.lastTaxTime, now, convert.ethToWeiBN(zoneOwner.balance));
            if (myTaxesDue.gte(convert.ethToWei(zoneOwner.balance)))
                zoneStatus = types_1.ZoneStatus.Claimable;
            else
                zoneStatus = types_1.ZoneStatus.Occupied;
        }
    }
    return {
        geohash: geohash6,
        status: zoneStatus,
        address: zoneAddress,
        owner: zoneOwner.address !== constants.ADDRESS_ZERO ? zoneOwner : undefined,
        auction: undefined,
    };
};
// -------------------- //
//        Getters       //
// -------------------- //
exports.getCountryFloorPrice = async (country, protocolControllerContract, provider) => {
    validate.countryCode(country);
    const countryPrice = await protocolControllerContract.getCountryFloorPrice(`0x${util.toNBytes(country, 2)}`);
    return convert.weiToEthNumber(countryPrice.toString());
};
exports.getGlobalParams = async (protocolControllerContract, provider) => {
    const globalParams = await protocolControllerContract.getGlobalParams();
    return { bidPeriod: globalParams.bidPeriod.toNumber(), cooldownPeriod: globalParams.cooldownPeriod.toNumber(), minRaise: globalParams.minRaise.toNumber(), entryFee: globalParams.entryFee.toNumber(), zoneTax: globalParams.zoneTax.toNumber() / 100 };
};
exports.isZoneOwned = async (geohash6, zoneFactoryContract, provider) => {
    validate.geohash(geohash6, 6);
    const zoneExists = await zoneFactoryContract.zoneExists(convert.asciiToHex(geohash6).substring(0, 14));
    if (!zoneExists)
        return false;
    // there is a zone contract
    // check if someone is owner now
    const zoneAddress = await zoneFactoryContract.geohashToZone(convert.asciiToHex(geohash6).substring(0, 14));
    const zoneContract = await contract.get(provider, types_1.DetherContract.Zone, zoneAddress);
    const zoneOwner = exports.zoneOwnerArrToObj(await zoneContract.getZoneOwner());
    if (zoneOwner &&
        zoneOwner.address != "0x0000000000000000000000000000000000000000") {
        return true;
    }
    return false;
};
exports.getZoneByGeohash = async (geohash6, zoneFactoryContract, provider) => {
    validate.geohash(geohash6, 6);
    const zoneExists = await zoneFactoryContract.zoneExists(convert.asciiToHex(geohash6).substring(0, 14));
    if (!zoneExists)
        return { geohash: geohash6, status: types_1.ZoneStatus.Inexistent };
    // there exists a zone contract
    const zoneAddress = await zoneFactoryContract.geohashToZone(convert.asciiToHex(geohash6).substring(0, 14));
    const zoneContract = await contract.get(provider, types_1.DetherContract.Zone, zoneAddress);
    const zoneOwner = exports.zoneOwnerArrToObj(await zoneContract.getZoneOwner());
    const auctionID = await zoneContract.currentAuctionId();
    // get zone price
    if (auctionID > 0) {
        const lastAuction = exports.zoneAuctionArrToObj(await zoneContract.getLastAuction());
        return exports.toLiveZoneRaw(zoneAddress, geohash6, zoneContract, zoneOwner, lastAuction);
    }
    else {
        return exports.toLiveZoneNoBidYet(zoneAddress, geohash6, zoneContract, zoneOwner);
    }
};
// TO DO GET ZONE WHEN ITS CLAIMED AND WIN AFTER AUCTION
// BECAUSE OWNER IS SET TO THE PREVIOUS AUCTION OWNER AND NOT THE CLAIMER
// DO THE SAME IN GETZONE()
exports.getZoneByAddress = async (address, provider) => {
    validate.ethAddress(address);
    let zoneContract;
    try {
        zoneContract = await contract.get(provider, types_1.DetherContract.Zone, address);
    }
    catch (e) {
        return { geohash: "000000", status: types_1.ZoneStatus.Inexistent };
    }
    const zoneOwner = exports.zoneOwnerArrToObj(await zoneContract.getZoneOwner());
    const geohash6 = await zoneContract.geohash();
    const auctionID = await zoneContract.currentAuctionId();
    if (auctionID > 0) {
        const lastAuction = exports.zoneAuctionArrToObj(await zoneContract.getLastAuction());
        return exports.toLiveZoneRaw(address, convert.hexToAscii(geohash6), zoneContract, zoneOwner, lastAuction);
    }
    else {
        return exports.toLiveZoneNoBidYet(address, convert.hexToAscii(geohash6), zoneContract, zoneOwner);
    }
};
exports.getZonesStatus = async (geohash6List, zoneFactoryContract, provider) => Promise.all(geohash6List.map((geohash6) => exports.getZoneByGeohash(geohash6, zoneFactoryContract, provider)));
exports.isZoneOpened = async (geohash6, country, geoRegistryContract) => {
    validate.geohash(geohash6, 6);
    const countryOpen = await geoRegistryContract.zoneIsEnabled(convert.asciiToHex(country).substring(0, 6));
    if (countryOpen === false) {
        return false;
    }
    const zoneAvailable = await geoRegistryContract.zoneInsideBiggerZone(convert.asciiToHex(country).substring(0, 6), convert.asciiToHex(geohash6).substring(0, 10));
    if (zoneAvailable === false) {
        return false;
    }
    return true;
};
exports.isZoneOwner = async (address, zoneFactoryContract, provider) => {
    validate.ethAddress(address);
    try {
        const zoneAddr = await zoneFactoryContract.ownerToZone(address);
        const zoneGeohash = convert
            .hexToAscii(await zoneFactoryContract.zoneToGeohash(zoneAddr))
            .slice(0, 6);
        return {
            zoneAddr,
            zoneGeohash,
        };
    }
    catch (e) {
        return false;
    }
};
exports.getOpenBid = async (address, zoneFactoryContract) => {
    validate.ethAddress(address);
    try {
        const zoneBid = await zoneFactoryContract.activeBidderToZone(address);
        if (zoneBid != "0x0000000000000000000000000000000000000000")
            return zoneBid;
        else
            return "no";
    }
    catch (e) {
        return false;
    }
};
// DO NOT USE TO KNOW IF CAN WITHDRAW FROM THE AUCTION
exports.isBidderOnthisAuction = async (zoneAddress, ethAddress, auctionID, provider) => {
    const zoneContract = await contract.get(provider, types_1.DetherContract.Zone, zoneAddress);
    const result = await zoneContract.auctionBids(auctionID, ethAddress);
    return convert.weiToEthNumber(result);
};
// -------------------- //
//        Setters       //
// -------------------- //
// ERC223
exports.create = async (country, geohash6, amount, zoneFactoryContract, detherTokenContract, wallet, txOptions) => {
    console.log('detherjs create');
    validate.countryCode(country);
    validate.geohash(geohash6, 6);
    validate.minStake(amount);
    const zoneExists = await zoneFactoryContract.zoneExists(convert.asciiToHex(geohash6).substring(0, 14));
    if (zoneExists) {
        return exports.claimFree(geohash6, wallet, zoneFactoryContract, detherTokenContract, txOptions);
    }
    /*const detherTokenContract = await contract.get(
      wallet.provider,
      DetherContract.DetherToken,
      undefined,
      [constants.ERC223_TRANSFER_ABI]
    );*/
    console.log('detherjs create params', zoneFactoryContract.address, amount, country, geohash6, createZoneBytes(country, geohash6), txOptions);
    if (!txOptions.gasLimit)
        txOptions.gasLimit = 450000;
    return detherTokenContract
        .connect(wallet)
        .transferAndCall(zoneFactoryContract.address, ethers_1.ethers.utils.parseEther(amount.toString()), 
    // convert.ethToWei(amount),
    createZoneBytes(country, geohash6), txOptions); // erc223 call
};
// TO DO ADD PARAM HERE
// ERC223
exports.claimFree = async (geohash6, wallet, zoneFactoryContract, detherTokenContract, txOptions) => {
    validate.geohash(geohash6, 6);
    const zoneAddress = await zoneFactoryContract.geohashToZone(convert.asciiToHex(geohash6).substring(0, 14));
    return detherTokenContract
        .connect(wallet)
        .transferAndCall(zoneAddress, convert.ethToWei(constants.MIN_ZONE_STAKE), "0x41", txOptions); // erc223 call
};
// ERC223
exports.bid = async (geohash6, bidAmount, zoneFactoryContract, detherTokenContract, wallet, txOptions) => {
    validate.geohash(geohash6, 6);
    try {
        const zoneAddress = await zoneFactoryContract.geohashToZone(convert.asciiToHex(geohash6).substring(0, 14));
        return detherTokenContract
            .connect(wallet)
            .transferAndCall(zoneAddress, convert.ethToWei(bidAmount), "0x42", txOptions); // erc223 call
    }
    catch (e) {
        console.log("impossible to bid here", e);
    }
};
// ERC223
exports.topUp = async (geohash6, topUpAmount, zoneFactoryContract, detherTokenContract, wallet, txOptions) => {
    validate.geohash(geohash6, 6);
    const zoneAddress = await zoneFactoryContract.geohashToZone(convert.asciiToHex(geohash6).substring(0, 14));
    return detherTokenContract
        .connect(wallet)
        .transferAndCall(zoneAddress, topUpAmount, "0x43", txOptions); // erc223 call
};
exports.release = async (geohash6, zoneFactoryContract, wallet, txOptions) => {
    validate.geohash(geohash6, 6);
    const zoneAddress = await zoneFactoryContract.geohashToZone(convert.asciiToHex(geohash6).substring(0, 14));
    const zoneContract = await contract.get(wallet.provider, types_1.DetherContract.Zone, zoneAddress);
    return zoneContract.connect(wallet).release(txOptions);
};
exports.withdrawFromAuction = async (geohash6, auctionId, zoneFactoryContract, wallet, txOptions) => {
    validate.geohash(geohash6, 6);
    const zoneAddress = await zoneFactoryContract.geohashToZone(convert.asciiToHex(geohash6).substring(0, 14));
    const zoneContract = await contract.get(wallet.provider, types_1.DetherContract.Zone, zoneAddress);
    return zoneContract.connect(wallet).withdrawFromAuction(auctionId, txOptions);
};
exports.withdrawFromAuctionAddress = async (zoneAddress, auctionId, wallet, txOptions) => {
    validate.ethAddress(zoneAddress);
    const zoneContract = await contract.get(wallet.provider, types_1.DetherContract.Zone, zoneAddress);
    return zoneContract.connect(wallet).withdrawFromAuction(auctionId, txOptions);
};
const checkIfWithdrawable = async (zoneContract, ethAddress, auctionID) => {
    const result = await zoneContract.auctionBids(auctionID, ethAddress);
    if (convert.weiToEthNumber(result) > 0) {
        // let auction = [];
        // let highestBid: number;
        // ({auction, highestBid} = await zoneContract.getAuction(1));
        return auctionID;
        // if (formatedAuction.highestBidder !== ethAddress) return auctionID;
        // else return 0
    }
    else {
        return 0;
    }
};
// TO DO:
// improve this function to only withdraw from known auction, to avoid doing useles call to previous zone auction
exports.withdrawAuctionsRaw = async (zoneAddress, wallet, txOptions) => {
    validate.ethAddress(zoneAddress);
    const zoneContract = await contract.get(wallet.provider, types_1.DetherContract.Zone, zoneAddress);
    const numberOfAuctions = await zoneContract.currentAuctionId();
    // TO DO :
    // CHECK IF WE CAN HAVE DTH IN MULTIPLE AUCTION OR ITS IMPOSSIBLE NOW
    const rawArray = [];
    let counter = numberOfAuctions > 20 ? 1 : numberOfAuctions - 20; // we'll check only the last 20 auctions (40 days minimum)
    for (let i = 1; i <= numberOfAuctions; i++) {
        rawArray.push(i);
    }
    let bidToWithdraws = await Promise.all(rawArray.map((auctionId) => checkIfWithdrawable(zoneContract, wallet.address, auctionId)));
    const filteredArrays = bidToWithdraws.filter((value, index) => {
        return value > 0;
    });
    if (filteredArrays.length > 0) {
        return zoneContract
            .connect(wallet)
            .withdrawFromAuctions(filteredArrays, txOptions);
    }
    else {
        return zoneContract.connect(wallet).withdrawDth(txOptions);
    }
};
exports.withdrawFromAuctions = async (geohash6, auctionIds, zoneFactoryContract, wallet, txOptions) => {
    validate.geohash(geohash6, 6);
    const zoneAddress = await zoneFactoryContract.geohashToZone(convert.asciiToHex(geohash6).substring(0, 14));
    const zoneContract = await contract.get(wallet.provider, types_1.DetherContract.Zone, zoneAddress);
    return zoneContract
        .connect(wallet)
        .withdrawFromAuctions(auctionIds, txOptions);
};
exports.withdrawFromAuctionsAddress = async (zoneAddress, auctionIds, wallet, txOptions) => {
    validate.ethAddress(zoneAddress);
    const zoneContract = await contract.get(wallet.provider, types_1.DetherContract.Zone, zoneAddress);
    return zoneContract
        .connect(wallet)
        .withdrawFromAuctions(auctionIds, txOptions);
};
exports.withdrawDth = async (geohash6, zoneFactoryContract, wallet, txOptions) => {
    validate.geohash(geohash6, 6);
    const zoneAddress = await zoneFactoryContract.geohashToZone(convert.asciiToHex(geohash6).substring(0, 14));
    const zoneContract = await contract.get(wallet.provider, types_1.DetherContract.Zone, zoneAddress);
    return zoneContract.connect(wallet).withdrawDth(txOptions);
};
exports.withdrawDthAddress = async (zoneAddress, wallet, txOptions) => {
    validate.ethAddress(zoneAddress);
    const zoneContract = await contract.get(wallet.provider, types_1.DetherContract.Zone, zoneAddress);
    return zoneContract.connect(wallet).withdrawDth(txOptions);
};
exports.processState = async (zoneAddress, wallet, txOptions) => {
    try {
        const zoneContract = await contract.get(wallet.provider, types_1.DetherContract.Zone, zoneAddress);
        return zoneContract.connect(wallet).processState(txOptions);
    }
    catch (e) {
        console.log("error detherJS process state");
    }
};
//# sourceMappingURL=zone.js.map