"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.hexToAscii = exports.add0x = exports.remove0x = exports.asciiToHex = exports.ethToWeiBN = exports.ethToWei = exports.weiToEthNumber = exports.weiToEth = exports.padZeroLeft = exports.padZeroRight = void 0;
const ethers_1 = require("ethers");
// import Web3 from 'web3';
// const web3 = new Web3();
exports.padZeroRight = (str, len) => `${str}${"0".repeat(len - exports.remove0x(str).length)}`;
exports.padZeroLeft = (str, len) => `${"0".repeat(len - exports.remove0x(str).length)}${str}`;
exports.weiToEth = (wei) => ethers_1.ethers.utils.formatEther(wei);
exports.weiToEthNumber = (wei) => Number(ethers_1.ethers.utils.formatEther(wei));
exports.ethToWei = (eth) => ethers_1.ethers.utils.parseEther(eth.toString()).toString();
exports.ethToWeiBN = (eth) => ethers_1.ethers.utils.bigNumberify(exports.ethToWei(eth));
exports.asciiToHex = (ascii) => exports.padZeroRight(ethers_1.ethers.utils.hexlify(ethers_1.ethers.utils.toUtf8Bytes(ascii)), 64);
exports.remove0x = (txt) => txt.startsWith("0x") ? txt.slice(2) : txt;
exports.add0x = (txt) => txt.startsWith("0x") ? txt : `0x${txt}`;
exports.hexToAscii = (hex) => ethers_1.ethers.utils.parseBytes32String(exports.add0x(exports.padZeroRight(hex, 64)));
//# sourceMappingURL=convert.js.map